unit f_dbtest2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  qs_stat_tlb,
  //Definitions,
  com_common_consts,
  qs_statevents,
  StdCtrls, Buttons, ExtCtrls, Spin;

type
  TForm_Bench_OL = class(TForm)
    Panel_Bench: TPanel;
    Label2: TLabel;
    LA_OL: TLabel;
    LB_BP: TListBox;
    BB_Fill_BP: TBitBtn;
    BB_Bench: TBitBtn;
    BB_Load_OL: TBitBtn;
    LB_SerNoA: TListBox;
    BB_Fill_SerNo: TBitBtn;
    LB_Merkmale: TListBox;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    BB_Kat_Bench_OL: TBitBtn;
    BB_Raus: TBitBtn;
    LB_PartKeys: TListBox;
    Label6: TLabel;
    CB_R_Key: TComboBox;
    Label7: TLabel;
    ED_Part_A: TEdit;
    ED_Part_B: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ED_Gap: TEdit;
    Label11: TLabel;
    LB_SerNoB: TListBox;
    Label12: TLabel;
    Label13: TLabel;
    Panel2: TPanel;
    LA_Catalog: TLabel;
    Label5: TLabel;
    LA_Anzahl: TLabel;
    LA_Output: TLabel;
    LA_SubKat: TLabel;
    BB_Next: TBitBtn;
    BB_NextSub: TBitBtn;
    BB_NextKat: TBitBtn;
    BB_FirstKat: TBitBtn;
    BB_FirstSub: TBitBtn;
    BB_First: TBitBtn;
    Label14: TLabel;
    Label15: TLabel;
    LA_PartKey: TLabel;
    ED_2001: TEdit;
    BB_QueryFirst: TBitBtn;
    BB_QueryNext: TBitBtn;
    CB_AllParts: TCheckBox;
    LA_Fehler: TLabel;
    BB_LastBatch: TBitBtn;
    BB_NextBatch: TBitBtn;
    SE_Partkey: TSpinEdit;
    Label16: TLabel;
    LA_Batchno: TLabel;
    procedure BB_Fill_BPClick(Sender: TObject);
    procedure BB_BenchClick(Sender: TObject);
    procedure BB_Fill_SerNoClick(Sender: TObject);
    procedure BB_Load_OLClick(Sender: TObject);
    procedure BB_FirstKatClick(Sender: TObject);
    procedure BB_NextKatClick(Sender: TObject);
    procedure BB_FirstSubClick(Sender: TObject);
    procedure BB_NextSubClick(Sender: TObject);
    procedure BB_FirstClick(Sender: TObject);
    procedure BB_NextClick(Sender: TObject);
    procedure BB_Kat_Bench_OLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BB_QueryFirstClick(Sender: TObject);
    procedure BB_QueryNextClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BB_LastBatchClick(Sender: TObject);
    procedure BB_NextBatchClick(Sender: TObject);
    procedure SE_PartkeyChange(Sender: TObject);
  private
    { Private-Deklarationen }
    CatalogKey    : Integer;
    SubCatalogs   : Integer;
    SubCatalogKey : Integer;
    ColKeyList    : OleVariant;
  public
    { Public-Deklarationen }
    // Handle for accessing qs-STAT functionalities
    qsstatHandle : longint;
    hThreadEnde  : THandle;

    // qs-STAT Object
    IQsSTAT : ITQsstatRemoteControl;
    IQsStatDb : IDataBase;
    IQsStatCat : IEnumCatalogue;
    RemoteServer : boolean;

    // Object for connection point IQsEvents
    EventSink : TIQsEvents;

    // Nr. of characteristics loaded
    NumOfCharcteristics : integer;
  end;

var
  Form_Bench_OL: TForm_Bench_OL;

implementation

{$R *.DFM}

procedure TForm_Bench_OL.BB_Fill_BPClick(Sender: TObject);
var
  KeyList    : OleVariant;
  BPList     : OleVariant;
  i          : Integer;
  QHandel    : Integer;
  FHandle    : Integer;
  rc         : Integer;
  PartKey    : Integer;
  KResList   : OleVariant;
begin
  Screen.Cursor := crHourglass;
  KeyList := VarArrayCreate([0, 0], varInteger);
  VarArrayLock(KeyList);
  KeyList[0] := 0;
  VarArrayUnLock(KeyList);

  if IQsStatDb.Get_n_Buildphases(qsstatHandle, KeyList,12, BPList) = S_OK then
  {
  if IQsStatDb.GetBuildphases(qsstatHandle, 'TTO', 'J1', BPList) = S_OK then
  }
  begin
    VarArrayLock(BPList);
    LB_BP.Clear;
    for i := VarArrayLowBound(BPList, 1) to VarArrayHighBound(BPList, 1) do
    begin
      LB_BP.Items.Add(BPList[i]);
      LB_BP.Selected[LB_BP.Items.Count - 1] := True;
    end;
    VarArrayUnLock(BPList);
  end;
  if CB_AllParts.Checked then
  begin
    for i := 1 to 20 do
    begin
      LB_PartKeys.Items.Add(IntToStr(i));
      LB_PartKeys.Selected[LB_PartKeys.Items.Count - 1] := True;
    end;
  end else
  begin
    IQsStatDb.CreateQuery(qsstatHandle, QHandel);
    IQsStatDb.CreateFilterFromSQL(qsstatHandle, 'TETEIL IN (SELECT DISTINCT ETEIL FROM ERGEBNIS)', FHandle);
    IQsStatDb.AddFilterToQuery( qsstatHandle, QHandel, FHandle, PART_LEVEL_C, 0, 0);
    LB_PartKeys.Items.Clear;
    rc := IQsStatDb.GetFirstPartQuery( qsstatHandle, QHandel, NULL, PartKey, KResList);
    while rc = 0 do
    begin
      LB_PartKeys.Items.Add(IntToStr(PartKey));
      LB_PartKeys.Selected[LB_PartKeys.Items.Count - 1] := True;
      rc := IQsStatDb.GetNextPartQuery( qsstatHandle, QHandel, PartKey, KResList);
    end;
    IQsStatDb.FreeFilter(qsstatHandle, FHandle);
    IQsStatDb.FreeQuery(qsstatHandle, QHandel);
  end;
  Screen.Cursor := crDefault;
end;

procedure TForm_Bench_OL.BB_BenchClick(Sender: TObject);
var
  i          : Integer;
  j          : Integer;
  BPList     : OleVariant;
  PKList     : OleVariant;
  OPList     : OleVariant;
// MA  FirstPhase,
// MA  LastPhase  : WideString;
  rc         : HResult;
begin
  rc := 0;
  if LB_BP.SelCount > 0 then
  begin
    Screen.Cursor := crHourGlass;

    BPList := VarArrayCreate([0, LB_BP.SelCount - 1], varOleStr);
    VarArrayLock(BPList);
    j := 0;
    for i := 0 to LB_BP.Items.Count - 1 do
    begin
      if LB_BP.Selected[i] then
      begin
        BPList[j] := LB_BP.Items[i];
        Inc(j);
      end;
    end;

    {
    // Test: erste und letzte selektierte Bauphase
    FirstPhase := '';
    for i := 0 to LB_BP.Items.Count - 1 do
    begin
      if LB_BP.Selected[i] then
      begin
        if FirstPhase = '' then FirstPhase := LB_BP.Items[i];
        LastPhase := LB_BP.Items[i];
      end;
    end;
    rc := IQsStatDb.GetBuildphases(qsstatHandle, FirstPhase, LastPhase, BPList);
    VarArrayLock(BPList);
    // Test Ende
    }
    PKList := VarArrayCreate([0, LB_PartKeys.SelCount - 1], varInteger);
    VarArrayLock(PKList);
    j := 0;
    for i := 0 to LB_PartKeys.Items.Count - 1 do
    begin
      if LB_PartKeys.Selected[i] then
      begin
        PKList[j] := StrToInt(LB_PartKeys.Items[i]);
        Inc(j);
      end;
    end;
    OPList := VarArrayCreate([0, 0], varInteger);
    VarArrayLock(OPList);
    if CB_R_Key.ItemIndex >= 0 then
    begin
      OPList[0] := StrToInt(CB_R_Key.Items[CB_R_Key.ItemIndex]);
    end else
    begin
      OPList[0] := 5210;
    end;
    VarArrayUnLock(PKList);
    rc := rc or IQsStatDb.Benchmark(qsstatHandle, PKList, BPList, OPList);
    VarArrayUnLock(OPList);
    VarArrayUnLock(BPList);
    Screen.Cursor := crDefault;
  end;
  if rc <> 0 then
  begin
    LA_Fehler.Visible := True;
  end else
  begin
    LA_Fehler.Visible := False;
  end;
end;

procedure TForm_Bench_OL.BB_Fill_SerNoClick(Sender: TObject);
var
  SerialNo        : WideString;
  rc              : Integer;
  QueryHandle     : Integer;
  Char_Key        : Integer;
  KResultList     : olevariant;
  PartKey         : Integer;
  OK              : Integer;
begin
  Val( ED_Part_A.Text, PartKey, OK);
  if OK <> 0 then PartKey := 10;
  Screen.Cursor := crHourGlass;
  LB_SerNoA.Items.Clear;
  rc := IQsStatDb.RecentSerNo_First( qsstatHandle,
                              PartKey,
                              SerialNo);
  while rc = 0 do
  begin
    LB_SerNoA.Items.Insert(0,SerialNo) ;
    rc := IQsStatDb.RecentSerNo_Next(  qsstatHandle,
                                SerialNo);
  end;

  LB_Merkmale.Items.Clear;
  IQsStatDb.CreateQuery( qsstatHandle, QueryHandle);
  rc := IQsStatDb.GetFirstCharQuery( qsstatHandle,
                                     QueryHandle,
                                     NULL,
                                     PartKey,
                                     Char_Key,
                                     KResultList);
  while rc = 0 do
  begin
    LB_Merkmale.Items.Add(IntToStr(Char_Key)) ;
    LB_Merkmale.Selected[LB_Merkmale.Items.Count - 1] := True;
    rc := IQsStatDb.GetNextCharQuery( qsstatHandle,
                                      QueryHandle,
                                      Char_Key,
                                      KResultList);
  end;
  IQsStatDb.FreeQuery(qsstatHandle, QueryHandle);

  Val( ED_Part_B.Text, PartKey, OK);
  if OK <> 0 then PartKey := 11;
  Screen.Cursor := crHourGlass;
  LB_SerNoB.Items.Clear;
  rc := IQsStatDb.RecentSerNo_First( qsstatHandle,
                                     PartKey,
                                     SerialNo);
  while rc = 0 do
  begin
    LB_SerNoB.Items.Insert(0,SerialNo) ;
    rc := IQsStatDb.RecentSerNo_Next(  qsstatHandle,
                                       SerialNo);
  end;

  Screen.Cursor := crDefault;
end;

procedure TForm_Bench_OL.BB_Load_OLClick(Sender: TObject);
var
  CharPairList : olevariant;
  //CharPair     : IntIntDoub_Rec_t;
  i            : Integer;
  AnzMerkm     : Integer;
  PartKeyA     : Integer;
  PartKeyB     : Integer;
  Gap          : Double;
  OK           : Integer;
  Posi         : Integer;
begin
  Val( ED_Part_A.Text, PartKeyA, OK);
  if OK <> 0 then PartKeyA := 10;
  Val( ED_Part_B.Text, PartKeyB, OK);
  if OK <> 0 then PartKeyB := 11;
  Posi := Pos(',', ED_Gap.Text);
  if Posi > 0 then
  begin
    ED_Gap.Text := Copy(ED_Gap.Text, 1, Posi - 1) + '.' + Copy(ED_Gap.Text, Posi + 1, 20);
  end;
  Val( ED_Gap.Text, Gap, OK);
  if OK <> 0 then Gap := 0.5;

  if (LB_SerNoA.ItemIndex >= 0) and (LB_SerNoB.ItemIndex >= 0) and (LB_Merkmale.ItemIndex >= 0) then
  begin
    Screen.Cursor := crHourglass;

    // Hier ist nur eine Merkmalskeyliste von Teil A erstellt worden,
    // es wird vorausgesetzt, da Teil A und B ber die gleiche Merkmalsanzahl
    // verfgen und korrespondierende Merkmale die gleichen Datenbank-Keys aufweisen.
    CharPairList := VarArrayCreate([0, (LB_Merkmale.SelCount * 3) - 1], varVariant);
    VarArrayLock(CharPairList);
    AnzMerkm := 0;
    for i := 0 to LB_Merkmale.Items.Count - 1 do
    begin
      if LB_Merkmale.Selected[i] then
      begin
        CharPairList[3 * AnzMerkm    ] := StrToInt(LB_Merkmale.Items[i]);
        CharPairList[3 * AnzMerkm + 1] := StrToInt(LB_Merkmale.Items[i]);
        CharPairList[3 * AnzMerkm + 2] := Gap;
        Inc(AnzMerkm);
      end;
    end;
    IQsStatDb.OpeningLine2( qsstatHandle,
                            LB_SerNoA.Items[LB_SerNoA.ItemIndex],
                            LB_SerNoB.Items[LB_SerNoB.ItemIndex],
                            PartKeyA,
                            PartKeyB,
                            CharPairList);  // jeweils ein Merkmalspaar mit einer Spaltbreite
    VarArrayUnLock(CharPairList);
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm_Bench_OL.BB_FirstKatClick(Sender: TObject);
var
  Res  : HResult;
  CatalogName : WideString;
  ICatalogue  : IEnumCatalogue;
begin
  ICatalogue := IQsSTAT as IEnumCatalogue;
  Res := ICatalogue.GetFirstCatalog( qsstatHandle,
                                  CatalogKey,
                                  ColKeyList,
                                  SubCatalogs,
                                  CatalogName);
  if Res = 0 then
  begin
    LA_Catalog.Caption := IntTostr(CatalogKey) + ': ' + CatalogName;
    LA_Anzahl.Caption := IntToStr(SubCatalogs);
    SubCatalogKey := 0;
    BB_NextKat.Enabled := True;
    if SubCatalogs > 0 then
    begin
      BB_FirstSub.Enabled := True;
    end else
    begin
      BB_FirstSub.Enabled := False;
    end;
    BB_First.Enabled := True;
  end else
  begin
    BB_NextKat.Enabled := False;
  end;
end;

procedure TForm_Bench_OL.BB_NextKatClick(Sender: TObject);
var
  Res  : HResult;
  CatalogName   : WideString;
  ICatalogue  : IEnumCatalogue;
begin
  ICatalogue := IQsSTAT as IEnumCatalogue;
  Res := ICatalogue.GetNextCatalog( qsstatHandle,
                                   CatalogKey,
                                   ColKeyList,
                                   SubCatalogs,
                                   CatalogName);
  if Res = 0 then
  begin
    LA_Catalog.Caption := IntTostr(CatalogKey) + ': ' + CatalogName;
    LA_Anzahl.Caption := IntToStr(SubCatalogs);
    SubCatalogKey := 0;
    BB_NextKat.Enabled := True;
    if SubCatalogs > 0 then
    begin
      BB_FirstSub.Enabled := True;
    end else
    begin
      BB_FirstSub.Enabled := False;
    end;
    BB_First.Enabled := True;
  end else
  begin
    BB_NextKat.Enabled := False;
  end;
end;

procedure TForm_Bench_OL.BB_FirstSubClick(Sender: TObject);
var
  Res           : HResult;
  CatalogName   : WideString;
  ICatalogue  : IEnumCatalogue;
begin
  ICatalogue := IQsSTAT as IEnumCatalogue;
  Res := ICatalogue.GetFirstSubCatalog(  qsstatHandle,
                                        CatalogKey,
                                        SubCatalogKey,
                                        CatalogName);
  if Res = 0 then
  begin
    LA_SubKat.Caption := IntToStr(SubCatalogKey) + ': ' + CatalogName;
    BB_NextSub.Enabled := True;
  end else
  begin
    SubCatalogKey := 0;
    LA_SubKat.Caption := '';
    BB_NextSub.Enabled := False;
  end;
end;

procedure TForm_Bench_OL.BB_NextSubClick(Sender: TObject);
var
  Res           : HResult;
  CatalogName   : WideString;
  ICatalogue  : IEnumCatalogue;
begin
  ICatalogue := IQsSTAT as IEnumCatalogue;
  Res := ICatalogue.GetNextSubCatalog( qsstatHandle,
                                      CatalogKey,
                                      SubCatalogKey,
                                      CatalogName);
  if Res = 0 then
  begin
    LA_SubKat.Caption := IntToStr(SubCatalogKey) + ': ' + CatalogName;
  end else
  begin
    SubCatalogKey := 0;
    LA_SubKat.Caption := '';
    BB_NextSub.Enabled := False;
  end;
end;

procedure TForm_Bench_OL.BB_FirstClick(Sender: TObject);
var
  Res        : HResult;
  EntryKey   : Integer;
  {
  OutStr     : WideString;
  i          : Integer;
  }
  OutNumStr  : WideString;
  OutNameStr : WideString;
  OutStr3    : WideString;
  OutStr4    : WideString;
  ICatalogue  : IEnumCatalogue;
begin
  ICatalogue := IQsSTAT as IEnumCatalogue;
  Res := ICatalogue.GetFirstCatalogEntryComplete(  qsstatHandle,
                                          CatalogKey,
                                          SubCatalogKey,
                                          EntryKey,
                                          OutNumStr,
                                          OutNameStr,
                                          OutStr3,
                                          OutStr4);
  if Res = 0 then
  begin
    LA_Output.Caption := IntToStr(EntryKey) + ': ' + OutNumStr;
    if OutNameStr <> '' then LA_Output.Caption := LA_Output.Caption + ' / ' + OutNameStr;
    if OutStr3 <> '' then LA_Output.Caption := LA_Output.Caption + ' / ' + OutStr3;
    if OutStr4 <> '' then LA_Output.Caption := LA_Output.Caption + ' / ' + OutStr4;
    BB_Next.Enabled := True;
  end
  else BB_Next.Enabled := False;
end;

procedure TForm_Bench_OL.BB_NextClick(Sender: TObject);
var
  Res  : HResult;
  EntryKey   : Integer;
  {
  OutStr     : WideString;
  i          : Integer;
  }
  OutNumStr  : WideString;
  OutNameStr : WideString;
  OutStr3    : WideString;
  OutStr4    : WideString;
  ICatalogue  : IEnumCatalogue;
begin
  ICatalogue := IQsSTAT as IEnumCatalogue;
  Res := ICatalogue.GetNextCatalogEntryComplete( qsstatHandle,
                                                EntryKey,
                                                OutNumStr,
                                                OutNameStr,
                                                OutStr3,
                                                OutStr4);
  if Res = 0 then
  begin
    LA_Output.Caption := IntToStr(EntryKey) + ': ' + OutNumStr;
    if OutNameStr <> '' then LA_Output.Caption := LA_Output.Caption + ' / ' + OutNameStr;
    if OutStr3 <> '' then LA_Output.Caption := LA_Output.Caption + ' / ' + OutStr3;
    if OutStr4 <> '' then LA_Output.Caption := LA_Output.Caption + ' / ' + OutStr4;
    BB_Next.Enabled := True;
  end
  else BB_Next.Enabled := False;
end;

procedure TForm_Bench_OL.BB_Kat_Bench_OLClick(Sender: TObject);
begin
  if Panel_Bench.Visible then
  begin
    Panel_Bench.Visible := False;
    BB_Kat_Bench_OL.Caption := 'Benchmark / OL';
  end else
  begin
    Panel_Bench.Visible := True;
    BB_Kat_Bench_OL.Caption := 'Catalogs';
  end;
end;

procedure TForm_Bench_OL.FormCreate(Sender: TObject);
begin
  CB_R_Key.ItemIndex := 0;
end;

procedure TForm_Bench_OL.BB_QueryFirstClick(Sender: TObject);
var
  QHandel    : Integer;
  FHandle    : Integer;
  KeyList    : OleVariant;
  KResList   : OleVariant;
  rc         : Integer;
  PartKey    : Integer;
begin
  IQsStatDb.CreateQuery(qsstatHandle, QHandel);
  IQsStatDb.CreateFilter(qsstatHandle, 1, 2001, ED_2001.Text, COMP_OP_LIKE_C, FHandle);
  IQsStatDb.AddFilterToQuery( qsstatHandle, QHandel, FHandle, PART_LEVEL_C, 0, 0);
  LB_PartKeys.Items.Clear;
  KeyList := VarArrayCreate([0,1], varInteger);
  KeyList[0] := 1001;
  KeyList[1] := 1002;
  rc := IQsStatDb.GetFirstPartQuery( qsstatHandle, QHandel, KeyList, PartKey, KResList);
  if rc = 0 then
  begin
    LA_PartKey.Caption := IntTostr(PartKey);
  end else
  begin
    LA_PartKey.Caption := 'Empty';
  end;
  BB_QueryFirst.Tag := QHandel;
end;

procedure TForm_Bench_OL.BB_QueryNextClick(Sender: TObject);
var
  QHandel    : Integer;
  KResList   : OleVariant;
  rc         : Integer;
  PartKey    : Integer;
begin
  QHandel := BB_QueryFirst.Tag;
  rc := IQsStatDb.GetNextPartQuery( qsstatHandle, QHandel, PartKey, KResList);
  if rc = 0 then
  begin
    LA_PartKey.Caption := IntTostr(PartKey);
  end else
  begin
    LA_PartKey.Caption := 'Empty';
  end;
end;

procedure TForm_Bench_OL.FormShow(Sender: TObject);
begin
  Panel_Bench.Align := alClient;
  BB_NextBatch.Enabled := False;
  LA_Batchno.Caption := 'Batch No.';
end;

procedure TForm_Bench_OL.BB_LastBatchClick(Sender: TObject);
var
  SerNo  : WideString;
  rc     : HResult;
begin
  rc := IQsStatDb.RecentSerNo_First(qsstatHandle, SE_PartKey.Value, SerNo);
  if rc = 0 then
  begin
    LA_Batchno.Caption := SerNo;
    BB_NextBatch.Enabled := True;
  end else
  begin
    LA_Batchno.Caption := 'No Batch No.';
    BB_NextBatch.Enabled := False;
  end;
end;

procedure TForm_Bench_OL.BB_NextBatchClick(Sender: TObject);
var
  SerNo  : WideString;
  rc     : HResult;
begin
  rc := IQsStatDb.RecentSerNo_Next(qsstatHandle, SerNo);
  if rc = 0 then
  begin
    LA_Batchno.Caption := SerNo;
    BB_NextBatch.Enabled := True;
  end else
  begin
    LA_Batchno.Caption := 'No Batch No.';
    BB_NextBatch.Enabled := False;
  end;
end;

procedure TForm_Bench_OL.SE_PartkeyChange(Sender: TObject);
begin
  LA_Batchno.Caption := 'Batch No.';
  BB_NextBatch.Enabled := False;
end;

end.
