VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form CatalogueDlg 
   Caption         =   "Get Catalogue"
   ClientHeight    =   5445
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   4290
   LinkTopic       =   "Form1"
   ScaleHeight     =   5445
   ScaleWidth      =   4290
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   840
      TabIndex        =   4
      Top             =   4920
      Width           =   1215
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2160
      TabIndex        =   3
      Top             =   4920
      Width           =   1215
   End
   Begin VB.Frame FA_Settings 
      Height          =   4635
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4050
      Begin VB.ComboBox COB_SubCatalogue 
         Height          =   315
         Left            =   1680
         Style           =   2  'Dropdown List
         TabIndex        =   6
         Top             =   600
         Width           =   2175
      End
      Begin VB.ComboBox COB_Catalogue 
         Height          =   315
         Left            =   1680
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   240
         Width           =   2175
      End
      Begin MSComctlLib.ListView LV_Catalogue 
         Height          =   3360
         Left            =   240
         TabIndex        =   5
         Top             =   1080
         Width           =   3615
         _ExtentX        =   6376
         _ExtentY        =   5927
         View            =   3
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         HideColumnHeaders=   -1  'True
         FullRowSelect   =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   3
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "#"
            Object.Width           =   528
         EndProperty
         BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   1
            Text            =   "Number"
            Object.Width           =   2638
         EndProperty
         BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   2
            Text            =   "Mark"
            Object.Width           =   2638
         EndProperty
      End
      Begin VB.Label LA_SubCatalogue 
         AutoSize        =   -1  'True
         Caption         =   "SubCatalogue:"
         Height          =   195
         Left            =   240
         TabIndex        =   7
         Top             =   720
         Width           =   1050
      End
      Begin VB.Label LA_Catalogue 
         AutoSize        =   -1  'True
         Caption         =   "Catalogue:"
         Height          =   195
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   765
      End
   End
End
Attribute VB_Name = "CatalogueDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CancelButton_Click()
  Me.Hide
End Sub

Private Sub OKButton_Click()
  Me.Hide
  ' To Do
  
End Sub

'-------------------------------------------------------------------------------------------
' Set COMBO -> Catalogue
'-------------------------------------------------------------------------------------------
Sub SetCatalogue()
  Dim IqsSTATCatalogue As IEnumCatalogue
  Dim CatalogueKey As Long
  Dim ColumnKeyList As Long
  Dim SubCatalogs As Long
  Dim CatalogueName As String
  Dim i As Integer
  
  '<- get interface ->
  Set IqsSTATCatalogue = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  i = 0
  CatalogueKey = 0
  ColumnKeyList = 0
  SubCatalogs = 0
  CatalogueName = ""
  
  '<- clearing combo ->
  COB_Catalogue.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATCatalogue.GetFirstCatalog(VBCOMClient2.qsstatHandle, _
                                        CatalogueKey, _
                                        ColumnKeyList, _
                                        SubCatalogs, _
                                        CatalogueName)
  Do While -1
    COB_Catalogue.List(i) = CatalogueName + " (" + CStr(CatalogueKey) + ")"
    COB_Catalogue.ItemData(i) = CatalogueKey
    Call IqsSTATCatalogue.GetNextCatalog(VBCOMClient2.qsstatHandle, _
                                         CatalogueKey, _
                                         ColumnKeyList, _
                                         SubCatalogs, _
                                         CatalogueName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop
  
ErrorHandler:
    
  '<- set first element of list by default selected ->
  If COB_Catalogue.ListCount < 1 Then COB_Catalogue.List(0) = "no data" Else COB_Catalogue.ListIndex = 0
End Sub

'-------------------------------------------------------------------------------------------
' Set COMBO -> SubCatalogue
'-------------------------------------------------------------------------------------------
Sub SetSubCatalogue()
  Dim IqsSTATSubCatalogue As IEnumCatalogue
  Dim SubCatalogueKey As Long
  Dim SubCatalogueName As String
  Dim CurCatalogueKey As Long
  Dim i As Integer
  
   '<- get interface ->
  Set IqsSTATSubCatalogue = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  i = 0
  CurCatalogueKey = 0
  If COB_Catalogue.ListCount > 0 Then
    CurCatalogueKey = COB_Catalogue.ItemData(COB_Catalogue.ListIndex)
  End If
  SubCatalogueKey = 0
  SubCatalogueName = ""
  
  '<- Looking for subcatalogue ->
  Dim IqsSTATCatalogue As IEnumCatalogue
  Dim CatalogueKey As Long
  Dim ColumnKeyList As Long
  Dim SubCatalogs As Long
  Dim CatalogueName As String
  Dim SubCat As Boolean
  
  '<- get interface ->
  Set IqsSTATCatalogue = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  i = 0
  CatalogueKey = 0
  ColumnKeyList = 0
  SubCatalogs = 0
  CatalogueName = ""
  
  SubCat = False
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATCatalogue.GetFirstCatalog(VBCOMClient2.qsstatHandle, _
                                        CatalogueKey, _
                                        ColumnKeyList, _
                                        SubCatalogs, _
                                        CatalogueName)
  If CatalogueKey = CurCatalogueKey Then
    If SubCatalogs > 0 Then
      SubCat = True
      CatalogueKey = CurCatalogueKey
    End If
  Else
  Do While i > -1
    Call IqsSTATCatalogue.GetNextCatalog(VBCOMClient2.qsstatHandle, _
                                         CatalogueKey, _
                                         ColumnKeyList, _
                                         SubCatalogs, _
                                         CatalogueName)
    On Error GoTo ErrorHandler
    If CatalogueKey = CurCatalogueKey Then
      If SubCatalogs > 0 Then
        SubCat = True
        CatalogueKey = CurCatalogueKey
      End If
      i = -2
    End If
    i = i + 1
  Loop
  End If
     
ErrorHandler:
  If SubCat = True Then
    '<- clearing combo ->
    COB_SubCatalogue.Clear
    SubCat = False
    i = 0
    '<- put data in to combo ->
    On Error GoTo ErrorHandler
    Call IqsSTATSubCatalogue.GetFirstSubCatalog(VBCOMClient2.qsstatHandle, _
                                                CatalogueKey, _
                                                SubCatalogueKey, _
                                                SubCatalogueName)
    Do While i > -1
      COB_SubCatalogue.List(i) = SubCatalogueName + " (" + CStr(SubCatalogueKey) + ")"
      COB_SubCatalogue.ItemData(i) = SubCatalogueKey
      On Error GoTo ErrorHandler
      Call IqsSTATSubCatalogue.GetNextSubCatalog(VBCOMClient2.qsstatHandle, _
                                                 CatalogueKey, _
                                                 SubCatalogueKey, _
                                                 SubCatalogueName)
      i = i + 1
    Loop
  End If
    
  '<- presetting QS_STAT Catalogue ->
  If COB_SubCatalogue.ListCount < 2 Then
    COB_SubCatalogue.List(0) = "no data"
    COB_SubCatalogue.Enabled = False
  Else
    COB_SubCatalogue.Enabled = True
  End If
  COB_SubCatalogue.ListIndex = 0
End Sub

'-------------------------------------------------------------------------------------------
' Get COMBO -> Catalogue
'-------------------------------------------------------------------------------------------
Private Sub COB_Catalogue_Click()
  
  COB_SubCatalogue.Clear
  SetSubCatalogue
  
  Dim IqsSTATCatalogue As IEnumCatalogue
  Dim CatalogueKey As Long
  Dim SubCatalogueKey As Long
  Dim EntryKey As Long
  Dim NumberStr As String
  Dim NameStr As String
  Dim Str3 As String 'only for intern usage
  Dim Str4 As String 'only for intern usage
  Dim LItem As ListItem
  Dim LHItem As ColumnHeader
  Dim rc As Long
  Dim i As Integer
    
  '<- get interface ->
  Set IqsSTATCatalogue = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  CatalogueKey = COB_Catalogue.ItemData(COB_Catalogue.ListIndex)
  SubCatalogueKey = 0
  EntryKey = 0
  NumberStr = ""
  NameStr = ""
  Str3 = ""
  Str4 = ""
    
  '<- don't show headers->
  LV_Catalogue.HideColumnHeaders = False
        
  '<- clearing listview ->
  LV_Catalogue.ListItems.Clear
  
  '<- put data in to listview ->
  On Error GoTo ErrorHandler
  Call IqsSTATCatalogue.GetFirstCatalogEntryComplete(VBCOMClient2.qsstatHandle, _
                                                     CatalogueKey, _
                                                     SubCatalogueKey, _
                                                     EntryKey, _
                                                     NumberStr, _
                                                     NameStr, _
                                                     Str3, Str4)
  For i = 0 To 1000
    Set LItem = LV_Catalogue.ListItems.Add(, , EntryKey, 0, 0)
    LItem.SubItems(1) = NumberStr
    LItem.SubItems(2) = NameStr
    Call IqsSTATCatalogue.GetNextCatalogEntryComplete(VBCOMClient2.qsstatHandle, _
                                                      EntryKey, _
                                                      NumberStr, _
                                                      NameStr, _
                                                      Str3, Str4)
    On Error GoTo ErrorHandler
  Next
  
ErrorHandler:
    
End Sub

'-------------------------------------------------------------------------------------------
' Get COMBO -> SubCatalogue
'-------------------------------------------------------------------------------------------
Private Sub COB_SubCatalogue_Click()
  If COB_SubCatalogue.ListCount > 1 Then
  'building catalogue listview
  Dim IqsSTATCatalogue As IEnumCatalogue
  Dim CatalogueKey As Long
  Dim SubCatalogueKey As Long
  Dim EntryKey As Long
  Dim NumberStr As String
  Dim NameStr As String
  Dim Str3 As String 'only for intern usage
  Dim Str4 As String 'only for intern usage
  Dim LItem As ListItem
  Dim LHItem As ColumnHeader
  Dim rc As Long
  Dim i As Integer
    
  '<- get interface ->
  Set IqsSTATCatalogue = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  CatalogueKey = COB_Catalogue.ItemData(COB_Catalogue.ListIndex)
  SubCatalogueKey = COB_SubCatalogue.ItemData(COB_SubCatalogue.ListIndex)
  EntryKey = 0
  NumberStr = ""
  NameStr = ""
  Str3 = ""
  Str4 = ""
    
  '<- don't show headers->
  LV_Catalogue.HideColumnHeaders = False
        
  '<- clearing listview ->
  LV_Catalogue.ListItems.Clear
  
  '<- put data in to listview ->
  On Error GoTo ErrorHandler
  Call IqsSTATCatalogue.GetFirstCatalogEntryComplete(VBCOMClient2.qsstatHandle, _
                                                     CatalogueKey, _
                                                     SubCatalogueKey, _
                                                     EntryKey, _
                                                     NumberStr, _
                                                     NameStr, _
                                                     Str3, Str4)
  For i = 0 To 1000
    Set LItem = LV_Catalogue.ListItems.Add(, , EntryKey, 0, 0)
    LItem.SubItems(1) = NumberStr
    LItem.SubItems(2) = NameStr
    Call IqsSTATCatalogue.GetNextCatalogEntryComplete(VBCOMClient2.qsstatHandle, _
                                                      EntryKey, _
                                                      NumberStr, _
                                                      NameStr, _
                                                      Str3, Str4)
    On Error GoTo ErrorHandler
  Next
  
ErrorHandler:
  
  
  End If
  
End Sub
