VERSION 5.00
Begin VB.Form GetPartInfoDlg 
   Caption         =   "Part Information"
   ClientHeight    =   4395
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   3150
   LinkTopic       =   "Form1"
   ScaleHeight     =   4395
   ScaleWidth      =   3150
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Daten position"
      Height          =   735
      Left            =   120
      TabIndex        =   12
      Top             =   2040
      Width           =   2895
      Begin VB.TextBox ED_PartNr 
         Height          =   285
         Left            =   2040
         TabIndex        =   13
         Text            =   "0"
         Top             =   240
         Width           =   615
      End
      Begin VB.Label LA_Part 
         AutoSize        =   -1  'True
         Caption         =   "Part No.:"
         Height          =   195
         Left            =   120
         TabIndex        =   14
         Top             =   360
         Width           =   630
      End
   End
   Begin VB.Frame FA_ResultOut 
      Caption         =   "Statistical result"
      Height          =   735
      Left            =   120
      TabIndex        =   9
      Top             =   2880
      Width           =   2895
      Begin VB.TextBox ED_PartInfo 
         BackColor       =   &H80000018&
         Height          =   285
         Left            =   1560
         TabIndex        =   11
         Top             =   240
         Width           =   1215
      End
      Begin VB.CommandButton BB_GetPartInfo 
         Caption         =   "Get Part"
         Height          =   375
         Left            =   120
         TabIndex        =   10
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Frame FA_Controls 
      Caption         =   "K-Fields"
      Height          =   1095
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   2895
      Begin VB.TextBox ED_Key 
         Height          =   285
         Left            =   2040
         TabIndex        =   6
         Text            =   "0"
         Top             =   240
         Width           =   615
      End
      Begin VB.TextBox ED_Subkey 
         Height          =   285
         Left            =   2040
         TabIndex        =   5
         Text            =   "0"
         Top             =   600
         Width           =   615
      End
      Begin VB.Label LA_Key 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "Key:"
         Height          =   195
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   345
      End
      Begin VB.Label LA_Subkey 
         AutoSize        =   -1  'True
         Caption         =   "SubKey:"
         Height          =   195
         Left            =   120
         TabIndex        =   7
         Top             =   720
         Width           =   600
      End
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   3840
      Width           =   1215
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1680
      TabIndex        =   2
      Top             =   3840
      Width           =   1215
   End
   Begin VB.Frame FA_Part 
      Caption         =   "Parts"
      Height          =   735
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   2895
      Begin VB.ComboBox COB_ENUMPart 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   240
         Width           =   2655
      End
   End
End
Attribute VB_Name = "GetPartInfoDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
  SetParts
  
  ED_Key.Text = VBCOMClient2.qs_PartKey
  ED_Subkey.Text = VBCOMClient2.qs_PartSubKey
  ED_PartNr.Text = VBCOMClient2.qs_PartPartNr
End Sub

Private Sub OKButton_Click()
  GetKey
  GetSubKey
  GetPartNr
  
  Me.Hide
End Sub

Private Sub CancelButton_Click()
  Me.Hide
End Sub

Private Sub BB_GetPartInfo_Click()
  GetParts
End Sub

'-------------------------------------------------------------------------------------------
' Set COMBO -> Part
'-------------------------------------------------------------------------------------------

Private Sub SetParts()
  Dim IqsSTATKField As IEnumFieldKeyName
  Dim KFieldKey As Long
  Dim KFieldSubKey As Long
  Dim KFieldName As String
  Dim i As Integer
  
  '<- get interface ->
  Set IqsSTATKField = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  i = 0
  KFieldKey = 0
  KFieldSubKey = 0
  KFieldName = ""
  
  '<- clearing combo ->
  COB_ENUMPart.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATKField.GetFirstPartField(VBCOMClient2.qsstatHandle, _
                                       KFieldKey, _
                                       KFieldSubKey, _
                                       KFieldName)
  Do While -1
    COB_ENUMPart.List(i) = KFieldName + " (" + CStr(KFieldKey) + ")"
    COB_ENUMPart.ItemData(i) = KFieldKey
    Call IqsSTATKField.GetNextPartField(VBCOMClient2.qsstatHandle, _
                                        KFieldKey, _
                                        KFieldSubKey, _
                                        KFieldName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop
  
ErrorHandler:
  
  '<- set first element of list by default selected ->
  COB_ENUMPart.ListIndex = 0
  If COB_ENUMPart.ListCount > 1 Then
    '<- set default element as selected if any ->
    For i = 0 To COB_ENUMPart.ListCount - 1
      If COB_ENUMPart.ItemData(i) = VBCOMClient2.qs_Part Then
        COB_ENUMPart.ListIndex = i
      End If
    Next
  Else
    COB_ENUMPart.List(0) = "no data"
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Get EDIT -> Key
'-------------------------------------------------------------------------------------------
Private Sub GetKey()
  '<- get selected part ->
  VBCOMClient2.qs_PartKey = CInt(ED_Key)
End Sub

'-------------------------------------------------------------------------------------------
' Get EDIT -> SubKey
'-------------------------------------------------------------------------------------------
Private Sub GetSubKey()
  '<- get selected char ->
  VBCOMClient2.qs_PartSubKey = CInt(ED_Subkey)
End Sub

'-------------------------------------------------------------------------------------------
' Get EDIT -> PartNr
'-------------------------------------------------------------------------------------------
Sub GetPartNr()
  '<- get PartNr ->
  VBCOMClient2.qs_PartPartNr = CInt(ED_PartNr)
End Sub
  
'-------------------------------------------------------------------------------------------
' Get EDIT -> PartNr
'-------------------------------------------------------------------------------------------

Private Sub GetParts()
  Dim value As String
  '<- get part value ->
  On Error GoTo ErrorHandler
  Call VBCOMClient2.qsstat.GetPartInfo(VBCOMClient2.qsstatHandle, _
                                     CLng(ED_Key.Text), _
                                     CLng(ED_PartNr.Text), _
                                     0, _
                                     value)
  If CStr(value) <> "" Then
    ED_PartInfo.Text = CStr(value)
  Else
    ED_PartInfo.Text = ""
  End If
ErrorHandler:

End Sub


