#if !defined(AFX_LOGINDIALOG_H__0AA92027_340A_41E4_AE18_8DBF8E10AC16__INCLUDED_)
#define AFX_LOGINDIALOG_H__0AA92027_340A_41E4_AE18_8DBF8E10AC16__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"
#include "afxwin.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LoginDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CLoginDialog dialog

struct UserStruct
{
	CString UserName;
};

struct ModStruct
{
	int ModKey;
	char ModName[255];
};

struct LangStruct
{
	int LangKey;
	char LangName[255];
};

class CLoginDialog : public CDialog
{
// Construction
public:
	CLoginDialog(CWnd* pParent = NULL);   // standard constructor

	virtual	~CLoginDialog();

	CString	GetUName();
	int		GetModKey();
	int		GetLangKey();

	void	SetServerObject(IUnknown * pIUnknown);
	HRESULT hr;
	CString	UserName;
	int		ModKey;
	int		LangKey;

	CArray<UserStruct*, UserStruct*> UserArray;
	IEnumUser *	pIqsSTATUser;

	CArray<ModStruct *, ModStruct*> ModuleArray;
	IEnumModule *	pIqsSTATModule;

	CArray<LangStruct *, LangStruct*> LanguageArray;
	IEnumLanguage *	pIqsSTATLanguage;
	
// Dialog Data
	//{{AFX_DATA(CLoginDialog)
	enum { IDD = IDD_LOGINDIALOG };
	CComboBox	m_COB_User;
	CComboBox	m_COB_Mod;
	CComboBox	m_COB_Lang;
	CString	m_PWD;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLoginDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CLoginDialog)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOGINDIALOG_H__0AA92027_340A_41E4_AE18_8DBF8E10AC16__INCLUDED_)
