// SetCustomKey.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient1.h"
#include "SetCustomKey.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetCustomKey dialog


CSetCustomKey::CSetCustomKey(CWnd* pParent /*=NULL*/)
	: CDialog(CSetCustomKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetCustomKey)
	//}}AFX_DATA_INIT	
	pIqsSTATModule = NULL;
	SelItem = -1;
}


void CSetCustomKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetCustomKey)

	DDX_Control(pDX, IDC_LISTVIEW, m_ListControl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetCustomKey, CDialog)
	//{{AFX_MSG_MAP(CSetCustomKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetCustomKey message handlers

BOOL CSetCustomKey::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	long	ModuleKey;
	BSTR	ModuleName;

	long	LanguageKey;
	BSTR	LanguageStName;
	BSTR	LanguageName;

	long	StrategyKey;
	BSTR	StrategyName;

	long	PrinterNr;
	BSTR	PrinterName;

	int		rc;
	int		i;
	char	M_buf[255];
	char	L_buf[255];
	char	s_str[40];
	char	s_str_add[255] = "";
	CString Str;	

	if (Type == 1) 
	{
		m_ListControl.InsertColumn(0, "Module", LVS_REPORT, 120);
		i = 0;
		rc = pIqsSTATModule->GetFirstModule(pqsSTATHandle,&ModuleKey,&ModuleName);
		while (rc == 0)	
		{
			_itoa(ModuleKey, M_buf, 10);
			KeyArr.Add(M_buf);
			Str = ModuleName;
			sprintf(s_str, "%s %s%d%s", Str, "(", ModuleKey, ")");
			m_ListControl.InsertItem(i, s_str);
			m_ListControl.SetItem(i, 0, LVS_REPORT, s_str, 0,0,0,0);
			Str.ReleaseBuffer();
			i++;
			rc = pIqsSTATModule->GetNextModule(pqsSTATHandle,&ModuleKey,&ModuleName);
		}
	}
	if (Type == 2) 
	{
		m_ListControl.InsertColumn(0, "Language", LVS_REPORT, 120);
		i = 0;
		rc = pIqsSTATLanguage->GetFirstLanguage(pqsSTATHandle,&LanguageName,&LanguageStName,&LanguageKey);
		while (rc == 0)	
		{
			_itoa(LanguageKey, L_buf, 10);
			KeyArr.Add(L_buf);
			Str  = LanguageName; // + LanguageKey;
			sprintf(s_str, "%s %s%d%s", Str, " (", LanguageKey, ")");
			m_ListControl.InsertItem(i, s_str);
			m_ListControl.SetItem(i, 0, LVS_REPORT, s_str, 0,0,0,0);
			Str.ReleaseBuffer();
			i++;
			rc = pIqsSTATLanguage->GetNextLanguage(pqsSTATHandle,&LanguageName,&LanguageStName,&LanguageKey);
		}
	}
	if (Type == 3)
	{
		m_ListControl.InsertColumn(0, "Strategy", LVS_REPORT, 120);
		i = 0;
		rc = pIqsSTATStrategy->GetFirstEvaluationStrategy(pqsSTATHandle,qs_Module,0,&StrategyKey,&StrategyName);
		while (rc == 0)	
		{
			Str  = StrategyName;
			sprintf(s_str, "%s %s%d%s", Str, " (", StrategyKey, ")");
			m_ListControl.InsertItem(i, s_str);
			m_ListControl.SetItem(i, 0, LVS_REPORT, s_str, 0,0,0,0);
			KeyArr.Add(Str);
			Str.ReleaseBuffer();
			i++;
			rc = pIqsSTATStrategy->GetNextEvaluationStrategy(pqsSTATHandle,qs_Module,0,&StrategyKey,&StrategyName);
		}
	}
	if (Type == 4)
	{
		m_ListControl.InsertColumn(0, "Strategy", LVS_REPORT, 120);
		i = 0;
		rc = pIqsSTATPrinter->GetFirstPrinter(pqsSTATHandle,&PrinterNr,&PrinterName);
		while (rc == 0)	
		{
			Str  = PrinterName;
			sprintf(s_str, "%s %s%d%s", Str, " (", StrategyKey, ")");
			m_ListControl.InsertItem(i, s_str);
			m_ListControl.SetItem(i, 0, LVS_REPORT, s_str, 0,0,0,0);
			KeyArr.Add(Str);
			Str.ReleaseBuffer();
			i++;
			rc = pIqsSTATPrinter->GetNextPrinter(pqsSTATHandle,&PrinterNr,&PrinterName);
		}
	}
	
	// Enable full row selection on List View
	m_ListControl.SetExtendedStyle(m_ListControl.GetExtendedStyle()|LVS_EX_FULLROWSELECT);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//------------------------------------------------------------------
//------------------------------------------------------------------

void CSetCustomKey::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumModule,(void**)&pIqsSTATModule);
	pIUnknown->QueryInterface(IID_IEnumLanguage,(void**)&pIqsSTATLanguage);
	pIUnknown->QueryInterface(IID_IEnumEvaluationStrategy,(void**)&pIqsSTATStrategy);
	pIUnknown->QueryInterface(IID_IEnumPrinter,(void**)&pIqsSTATPrinter);
	
	pqsSTATHandle = qsSTATHandle;
}

void	CSetCustomKey::SetItemType(int Tag)
{
	Type = Tag;
}

void	CSetCustomKey::SetModule(int Module)
{
	qs_Module = Module;
}

CString CSetCustomKey::GetTypeKey()
{
	if (SelItem > -1)
	{
		return KeyArr.GetAt(SelItem);
	}
	else
	{
		return "-1";
	}
}

CString CSetCustomKey::GetTypeName()
{
	return NameArr.GetAt(SelItem);
}

void CSetCustomKey::OnOK() 
{
	SelItem = m_ListControl.GetNextItem(-1, LVNI_SELECTED);
	CDialog::OnOK();
}
