#if !defined(AFX_QUERYFILTERDIALOG_H__60B50B6D_A12A_4A66_AD3F_85A1AF456CEF__INCLUDED_)
#define AFX_QUERYFILTERDIALOG_H__60B50B6D_A12A_4A66_AD3F_85A1AF456CEF__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// QueryFilterDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// QueryFilterDialog dialog

class QueryFilterDialog : public CDialog
{
// Construction
public:
	QueryFilterDialog(CWnd* pParent = NULL);   // standard constructor
	
// Dialog Data
	//{{AFX_DATA(QueryFilterDialog)
	enum { IDD = IDD_QUERYFILTERDIALOG };
	CListCtrl	m_PartsListControl;
	CListCtrl	m_CharsListControl;
	CButton	m_Check6;
	CButton	m_Check5;
	CButton	m_Check4;
	CButton	m_Check3;
	CButton	m_Check1;
	CButton	m_FilterExe6;
	CButton	m_FilterExe5;
	CButton	m_FilterExe4;
	CButton	m_FilterExe3;
	CButton	m_FilterExe1;
	CButton	m_Filter6;
	CButton	m_Filter5;
	CButton	m_Filter4;
	CButton	m_Filter3;
	CButton	m_Filter2;
	CButton	m_Check2;
	CButton	m_FilterExe2;
	CButton	m_Filter1;
	CString	m_List1;
	CString	m_List2;
	CString	m_Edit10;
	CString	m_Edit11;
	CString	m_Edit12;
	int		m_Edit3;
	CString	m_Edit4;
	CString	m_Edit5;
	CString	m_Edit6;
	int		m_Edit7;
	int		m_Edit8;
	int		m_Edit9;
	int		m_Edit1;
	int		m_Edit2;
	//}}AFX_DATA


	CString	GetKFieldNamePart(long KField_Key);

	CString	GetKFieldNameChar(long KField_Key);

	long QueryHandle;
	
	long CreateQuery();

	long ExecuteQuery(int SelItem);

	long CreateFilter(int KFieldList, int Item, CString Condition);

    long AddNewFilter(long QH, long FH, unsigned char QL);
    
	void FreeFilter(long FH);

	void SetPartsLB(long QH);

	void SetCharsLB(long QH);

    void SetServerObject(IUnknown * pIUnknown, long qsSTATHandle);
	
	long pqsSTATHandle;

	IEnumFieldKeyName * pIqsSTATFieldKeyName;
	
	IDataBase * pIqsSTATDataBase;
	
	long PartList[2];
	long CharList[2];

	int	Edit1;	
	int	Edit2;
	int	Edit3;
	int	Edit7;
	int	Edit8;
	int	Edit9;

	COleVariant KFieldListPart;
	COleVariant KFieldListChar;

	long arrindex[2];

	COleSafeArray KFieldListArr;
	COleSafeArray KFieldsArr;
	long p[2];


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(QueryFilterDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(QueryFilterDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnBBFilter1();
	afx_msg void OnBBFilter2();
	afx_msg void OnBBFilter3();
	afx_msg void OnBBFilter4();
	afx_msg void OnBBFilter5();
	afx_msg void OnBBFilter6();
	afx_msg void OnBBFilterExe1();
	afx_msg void OnBBFilterExe2();
	afx_msg void OnBBFilterExe3();
	afx_msg void OnBBFilterExe4();
	afx_msg void OnBBFilterExe5();
	afx_msg void OnBBFilterExe6();
	afx_msg void OnCheck1();
	afx_msg void OnCheck2();
	afx_msg void OnCheck3();
	afx_msg void OnCheck4();
	afx_msg void OnCheck5();
	afx_msg void OnCheck6();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QUERYFILTERDIALOG_H__60B50B6D_A12A_4A66_AD3F_85A1AF456CEF__INCLUDED_)
