#if !defined(AFX_ONLINETRANSMITION_H__077A1A32_593E_4E8E_8A2C_8106884802B4__INCLUDED_)
#define AFX_ONLINETRANSMITION_H__077A1A32_593E_4E8E_8A2C_8106884802B4__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"
#include "afxwin.h"
#include "qsEventSink.h"
#include "MainFrm.h"
#include "UpdateView.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OnlineTransmition.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COnlineTransmition dialog

class COnlineTransmition : public CDialog
{
// Construction
public:
	COnlineTransmition(CWnd* pParent = NULL);   // standard constructor

	long	pqsSTATHandle;

	ITQsstatRemoteControl*	pqsSTAT;

	void	SetItemType(int Tag);

	void	SetServerObject( CUpdateView* view, IUnknown * pIUnknown, long qsSTATHandle, CSink * mySink);

	void	TransmitOnline(int Mode);

	long	LastReadFilePos;

	CSink * SinkObj;
    CUpdateView* pView;


// Dialog Data
	//{{AFX_DATA(COnlineTransmition)
	enum { IDD = IDD_TRANSMIT_DIALOG };
	CEdit		m_Text;
	CString		m_Head;
	CString		m_Data;
	BOOL		m_ExtMode;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COnlineTransmition)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:


	// Generated message map functions
	//{{AFX_MSG(COnlineTransmition)
	virtual BOOL OnInitDialog() ;
	virtual void OnOK();
	afx_msg void OnBBHead();	
	afx_msg void OnBBData();
	afx_msg void OnBBGetHead();	
	afx_msg void OnBBGetData();
	afx_msg void OnBBGetText();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ONLINETRANSMITION_H__077A1A32_593E_4E8E_8A2C_8106884802B4__INCLUDED_)
