#if !defined(AFX_SELEKTCATALOGUE_H__BBE58DBB_397D_489D_9DEB_99C05282B23B__INCLUDED_)
#define AFX_SELEKTCATALOGUE_H__BBE58DBB_397D_489D_9DEB_99C05282B23B__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SelektCatalogue.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// SelektCatalogue dialog

struct CatStruct
{
	int  CatKey;
	char CatName[255];
};

struct SubCatStruct
{
	int SubCatKey;
	char SubCatName[255];
};


class SelektCatalogue : public CDialog
{
// Construction
public:
	SelektCatalogue(CWnd* pParent = NULL);   // standard constructor
	virtual	~SelektCatalogue();

// Dialog Data
	//{{AFX_DATA(SelektCatalogue)
	enum { IDD = IDD_SELECTCATALOGUE_DIALOG };
	CComboBox	m_COBCatalogue;
	CComboBox	m_COBSubCatalogue;
	CListCtrl	m_ListCatalogue;
	//}}AFX_DATA

	void	SetServerObject(IUnknown* pIUnknown, 
							long qsSTATHandle);

	ITQsstatRemoteControl*	pqsSTAT;

	IEnumCatalogue*	pIqsSTATCatalogue;
	
	long	pqsSTATHandle;
	
	void	SetCatalogue();
	int		GetCatalogue();
	
	void	SetSubCatalogue();
	int		GetSubCatalogue();	
	
	CArray<CatStruct *, CatStruct*> CatArray;
	CArray<SubCatStruct *, SubCatStruct*> SubCatArray;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SelektCatalogue)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SelektCatalogue)
		virtual BOOL OnInitDialog();
		afx_msg void OnSelchangeCatalogue();
		afx_msg void OnSelchangeSubCatalogue();
		virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SELEKTCATALOGUE_H__BBE58DBB_397D_489D_9DEB_99C05282B23B__INCLUDED_)
