#if !defined(AFX_SELEKTGRAFKEY_H__592DA8F3_F066_11D5_A7BA_00105A274BB6__INCLUDED_)
#define AFX_SELEKTGRAFKEY_H__592DA8F3_F066_11D5_A7BA_00105A274BB6__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"
#include "UpdateView.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SelektGrafKey.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSelektGrafKey dialog

class CSelektGrafKey : public CDialog
{
// Construction
public:
	CSelektGrafKey(CWnd* pParent = NULL);   // standard constructor

	void	SetServerObject(CUpdateView* view,
							IUnknown * pIUnknown, 
							long qsSTATHandle, 
							long ModuleNr);
	
	ITQsstatRemoteControl*	pqsSTAT;

	long	pqsSTATHandle;

	long	ModuleID;

	IEnumGraphic *	pIqsSTATGraphic;
	CUpdateView* pView;

	void	SetEnumGraphic();
	void	SetPartNr();
    void	SetCharNr();
	
	void	SetPart_x( int value);
	int		GetPart_x();
	
	void	SetChar_x( int value);
	int		GetChar_x();
	
	void	SetValue_x( int value);
	int		GetValue_x();
	
	void	SetPart_y( int value);
	int		GetPart_y();
	
	void	SetChar_y( int value);
	int		GetChar_y();
	
	void	SetValue_y( int value);
	int		GetValue_y();
	
	void	SetGraphicKey( int value);
	int		GetGraphicKey();
	
	void	SetGraphicSubkey( int value);
	int		GetGraphicSubkey();

	void	SetPageNr( int value);
	int		GetPageNr();

// Dialog Data
	//{{AFX_DATA(CSelektGrafKey)
	enum { IDD = IDD_SELECTGRAFKEY_DIALOG };
	CComboBox	m_ENUMGraphic;
	int		m_GrafKey;
    int		m_GrafSubKey;
	int		m_PartNr_x;
	int		m_CharNr_x;
	int		m_PartNr_y;
	int		m_CharNr_y;
	int		m_Graphic;
	int		m_PageNr;
	int		m_CharNr;
	int		m_Char_x;
	int		m_Char_y;
	int		m_Part_x;
	int		m_Part_y;
	int		m_PartNr;
	int		m_Value_x;
	int		m_Value_y;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSelektGrafKey)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSelektGrafKey)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnBBApply();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SELEKTGRAFKEY_H__592DA8F3_F066_11D5_A7BA_00105A274BB6__INCLUDED_)
