// UpdateView.h: interface for the CUpdateView class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UPDATEVIEW_H__E097DFE1_830D_4CEB_A4A0_FC7063D9CB32__INCLUDED_)
#define AFX_UPDATEVIEW_H__E097DFE1_830D_4CEB_A4A0_FC7063D9CB32__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CUpdateView  
{
public:
	CUpdateView();
	virtual ~CUpdateView();

	virtual HRESULT GetGraphicOrReport( int whattodo, int DoDraw = 0) = 0;
	virtual void UpdateStatusBar(int index, char* s) = 0;
	virtual void SetGrafikKey( int Key);
	virtual void SetGrafikSubKey( int Key);
	virtual void SetGrafikPart_x( int Key);
	virtual void SetGrafikPart_y( int Key);
	virtual void SetGrafikChar_x( int Key);
	virtual void SetGrafikChar_y( int Key);
	virtual void SetGrafikValue_x( int Key);
	virtual void SetGrafikValue_y( int Key);
	virtual void SetGrafikPageNr( int Key);
	virtual void SetReportName(LPTSTR FName);
	virtual void SetReportPart_x( int Key);
	virtual void SetReportPart_y( int Key);
	virtual void SetReportChar_x( int Key);
	virtual void SetReportChar_y( int Key);
	virtual void SetReportValue_x( int Key);
	virtual void SetReportValue_y( int Key);
	virtual void SetReportPageNr( int Key);


};

#endif // !defined(AFX_UPDATEVIEW_H__E097DFE1_830D_4CEB_A4A0_FC7063D9CB32__INCLUDED_)
