{ *****************************************************************************
  WARNING: This component file was generated using the EventSinkImp utility.
           The contents of this file will be overwritten everytime EventSinkImp
           is asked to regenerate this sink component.

  NOTE:    When using this component at the same time with the XXX_TLB.pas in
           your Delphi projects, make sure you always put the XXX_TLB unit name
           AFTER this component unit name in the USES clause of the interface
           section of your unit; otherwise you will get interface conflict
           errors from the Delphi compiler.

           EventSinkImp is written by Binh Ly (bly@castle.net)
  *****************************************************************************
  //Sink Classes//
  TIQsEvents
}

{$IFDEF VER100}
{$DEFINE D3}
{$ENDIF}

//SinkUnitName//
unit Qs_statEvents;

interface

uses
  Windows,
  ActiveX,
  Classes,
  ComObj,
  OleCtrls
  //SinkUses//
  , StdVCL
  , Qs_stat_TLB
  ;

type
  { backward compatibility types }
  {$IFDEF D3}
  OLE_COLOR = TOleColor;
  {$ENDIF}

  TQs_statEventsBaseSink = class (TComponent, IUnknown, IDispatch)
  protected
    { IUnknown }
    function QueryInterface(const IID: TGUID; out Obj): HResult; {$IFNDEF D3} override; {$ENDIF} stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;
  protected
    FCookie : integer;
    FCP : IConnectionPoint;
    FSinkIID : TGuid;
    FSource : IUnknown;
    function DoInvoke (DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var dps : TDispParams; pDispIds : PDispIdList;
      VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; abstract;
  public
    destructor Destroy; override;
    procedure Connect (pSource : IUnknown);
    procedure Disconnect;
    property SinkIID : TGuid read FSinkIID;
    property Source : IUnknown read FSource;
  end;

  //SinkImportsForwards//

  //SinkImports//

  //SinkIntfStart//

  //SinkEventsForwards//
  TIQsEventsOnGetAliveStateEvent = function  (Sender : TObject; out state: Integer): HResult of object;
  TIQsEventsOnDataAvailEvent = function  (Sender : TObject; NumOfChars: Integer): HResult of object;
  TIQsEventsOnQSSTATInitializedEvent = function  (Sender : TObject): HResult of object;
  TIQsEventsOnEvaluationDoneEvent = function  (Sender : TObject): HResult of object;
  TIQsEventsOnErrorEvent = function  (Sender : TObject; ErrorCode: Integer): HResult of object;
  TIQsEventsOnStatisticalAlarmEvent = function  (Sender : TObject; Alarm_EW_1: LongWord; Alarm_EW_2: LongWord; Alarm_QRK_L: LongWord; Alarm_QRK_S: LongWord; Alarm_CP: LongWord; Alarm_NO_SPC: LongWord; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult of object;
  TIQsEventsOnSystemAlarmEvent = function  (Sender : TObject; AlarmCode: LongWord): HResult of object;
  TIQsEventsOnUploadProgressEvent = function  (Sender : TObject; UploadChildHandle: Integer; UploadState: Integer; const filename: WideString; FileNo: Integer; NumOfFiles: Integer; PartNo: Integer; const PartKey: WideString; CharNo: Integer; const CharKey: WideString; NumOfChars: Integer; ValueNo: Integer; NumOfValues: Integer; ErrorNo: Integer; const ErrorMsg: WideString; TimeStamp: Integer): HResult of object;
  TIQsEventsOnDataAvailExtEvent = function  (Sender : TObject; handle: Integer; NumOfChars: Integer): HResult of object;
  TIQsEventsOnEvaluationDoneExtEvent = function  (Sender : TObject; handle: Integer): HResult of object;
  TIQsEventsOnStatisticalAlarmExtEvent = function  (Sender : TObject; handle: Integer; Alarm_EW_1: LongWord; Alarm_EW_2: LongWord; Alarm_QRK_L: LongWord; Alarm_QRK_S: LongWord; Alarm_CP: LongWord; Alarm_NO_SPC: LongWord; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult of object;
  TIQsEventsOnSystemAlarmExtEvent = function  (Sender : TObject; handle: Integer; AlarmCode: LongWord): HResult of object;
  TIQsEventsOnQueryOpenEvent = function  (Sender : TObject; handle: Integer; QueryHandle: Integer): HResult of object;
  TIQsEventsOnStatisticalAlarmExtVAEvent = function  (Sender : TObject; handle: Integer; Alarm_EW_1: OleVariant; Alarm_EW_2: OleVariant; Alarm_QRK_L: OleVariant; Alarm_QRK_S: OleVariant; Alarm_CP: OleVariant; Alarm_NO_SPC: OleVariant; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult of object;
  TIQsEventsOnApplicationCloseEvent = function  (Sender : TObject; var Accept: Integer): HResult of object;
  TIQsEventsOnDataSourceBeforeCloseEvent = function  (Sender : TObject; handle: Integer; DataSourceType: Integer; 
                                                       const Name : WideString; var Accept: Integer): HResult of object;
  TIQsEventsOnSavingDoneEvent = function  (Sender : TObject; handle: Integer): HResult of object;

  //SinkComponent//
  TIQsEvents = class (TQs_statEventsBaseSink
    , IQsEvents
  )
  protected
    function DoInvoke (DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var dps : TDispParams; pDispIds : PDispIdList;
      VarResult, ExcepInfo, ArgErr: Pointer): HResult; override;

    { IQsEvents }
    function IQsEvents.OnGetAliveState = DoOnGetAliveState;
    function IQsEvents.OnDataAvail = DoOnDataAvail;
    function IQsEvents.OnQSSTATInitialized = DoOnQSSTATInitialized;
    function IQsEvents.OnEvaluationDone = DoOnEvaluationDone;
    function IQsEvents.OnError = DoOnError;
    function IQsEvents.OnStatisticalAlarm = DoOnStatisticalAlarm;
    function IQsEvents.OnSystemAlarm = DoOnSystemAlarm;
    function IQsEvents.OnUploadProgress = DoOnUploadProgress;
    function IQsEvents.OnDataAvailExt = DoOnDataAvailExt;
    function IQsEvents.OnEvaluationDoneExt = DoOnEvaluationDoneExt;
    function IQsEvents.OnStatisticalAlarmExt = DoOnStatisticalAlarmExt;
    function IQsEvents.OnSystemAlarmExt = DoOnSystemAlarmExt;
    function IQsEvents.OnQueryOpen = DoOnQueryOpen;
    function IQsEvents.OnStatisticalAlarmExtVA = DoOnStatisticalAlarmExtVA;
    function IQsEvents.OnApplicationClose = DoOnApplicationClose;
    function IQsEvents.OnDataSourceBeforeClose = DoOnDataSourceBeforeClose;
    function IQsEvents.OnSavingDone = DoOnSavingDone;
  public
    { system methods }
    // Event handling functions
    hEvaluationEvent : THandle;
    hDataAvailEvent : THandle;
    hQueryOpenEvent : THandle;
    FEvalCount : integer;
    FDataCount : integer;

    CS_DATAVAIL : TRTLCriticalSection;
    constructor Create (pOwner : TComponent); override;
    destructor Destroy;override;
  protected
    //SinkInterface//
    function  DoOnGetAliveState(out state: Integer): HResult; stdcall;
    function  DoOnDataAvail(NumOfChars: Integer): HResult; stdcall;
    function  DoOnQSSTATInitialized: HResult; stdcall;
    function  DoOnEvaluationDone: HResult; stdcall;
    function  DoOnError(ErrorCode: Integer): HResult; stdcall;
    function  DoOnStatisticalAlarm(Alarm_EW_1: LongWord; Alarm_EW_2: LongWord; Alarm_QRK_L: LongWord; Alarm_QRK_S: LongWord; Alarm_CP: LongWord; Alarm_NO_SPC: LongWord; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult; stdcall;
    function  DoOnSystemAlarm(AlarmCode: LongWord): HResult; stdcall;
    function  DoOnUploadProgress(UploadChildHandle: Integer; UploadState: Integer; const filename: WideString; FileNo: Integer; NumOfFiles: Integer; PartNo: Integer; const PartKey: WideString; CharNo: Integer; const CharKey: WideString; NumOfChars: Integer; ValueNo: Integer; NumOfValues: Integer; ErrorNo: Integer; const ErrorMsg: WideString; TimeStamp: Integer): HResult; stdcall;
    function  DoOnDataAvailExt(handle: Integer; NumOfChars: Integer): HResult; stdcall;
    function  DoOnEvaluationDoneExt(handle: Integer): HResult; stdcall;
    function  DoOnStatisticalAlarmExt(handle: Integer; Alarm_EW_1: LongWord; Alarm_EW_2: LongWord; Alarm_QRK_L: LongWord; Alarm_QRK_S: LongWord; Alarm_CP: LongWord; Alarm_NO_SPC: LongWord; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult; stdcall;
    function  DoOnSystemAlarmExt(handle: Integer; AlarmCode: LongWord): HResult; stdcall;
    function  DoOnQueryOpen(handle: Integer; QueryHandle: Integer): HResult; stdcall;
    function  DoOnStatisticalAlarmExtVA(handle: Integer; Alarm_EW_1: OleVariant; Alarm_EW_2: OleVariant; Alarm_QRK_L: OleVariant; Alarm_QRK_S: OleVariant; Alarm_CP: OleVariant; Alarm_NO_SPC: OleVariant; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult; stdcall;
    function  DoOnApplicationClose(var Accept: Integer): HResult; stdcall;
    function  DoOnDataSourceBeforeClose(handle: Integer; DataSourceType: Integer; CONST Name: WideString;var Accept: Integer): HResult; stdcall;
    function  DoOnSavingDone(handle: Integer): HResult; stdcall;
  protected
    //SinkEventsProtected//
    FOnGetAliveState : TIQsEventsOnGetAliveStateEvent;
    FOnDataAvail : TIQsEventsOnDataAvailEvent;
    FOnQSSTATInitialized : TIQsEventsOnQSSTATInitializedEvent;
    FOnEvaluationDone : TIQsEventsOnEvaluationDoneEvent;
    FOnError : TIQsEventsOnErrorEvent;
    FOnStatisticalAlarm : TIQsEventsOnStatisticalAlarmEvent;
    FOnSystemAlarm : TIQsEventsOnSystemAlarmEvent;
    FOnUploadProgress : TIQsEventsOnUploadProgressEvent;
    FOnDataAvailExt : TIQsEventsOnDataAvailExtEvent;
    FOnEvaluationDoneExt : TIQsEventsOnEvaluationDoneExtEvent;
    FOnStatisticalAlarmExt : TIQsEventsOnStatisticalAlarmExtEvent;
    FOnSystemAlarmExt : TIQsEventsOnSystemAlarmExtEvent;
    FOnQueryOpen : TIQsEventsOnQueryOpenEvent;
    FOnStatisticalAlarmExtVA : TIQsEventsOnStatisticalAlarmExtVAEvent;
    FOnApplicationClose : TIQsEventsOnApplicationCloseEvent;
    FOnDataSourceBeforeClose : TIQsEventsOnDataSourceBeforeCloseEvent;
    FOnSavingDone : TIQsEventsOnSavingDoneEvent;
  published
    property EvalCount : longint read FEvalCount write FEvalCount;
    property DataCount : longint read FDataCount write FDataCount;
    //SinkEventsPublished//
    property OnGetAliveState : TIQsEventsOnGetAliveStateEvent read FOnGetAliveState write FOnGetAliveState;
    property OnDataAvail : TIQsEventsOnDataAvailEvent read FOnDataAvail write FOnDataAvail;
    property OnQSSTATInitialized : TIQsEventsOnQSSTATInitializedEvent read FOnQSSTATInitialized write FOnQSSTATInitialized;
    property OnEvaluationDone : TIQsEventsOnEvaluationDoneEvent read FOnEvaluationDone write FOnEvaluationDone;
    property OnError : TIQsEventsOnErrorEvent read FOnError write FOnError;
    property OnStatisticalAlarm : TIQsEventsOnStatisticalAlarmEvent read FOnStatisticalAlarm write FOnStatisticalAlarm;
    property OnSystemAlarm : TIQsEventsOnSystemAlarmEvent read FOnSystemAlarm write FOnSystemAlarm;
    property OnUploadProgress : TIQsEventsOnUploadProgressEvent read FOnUploadProgress write FOnUploadProgress;
    property OnDataAvailExt : TIQsEventsOnDataAvailExtEvent read FOnDataAvailExt write FOnDataAvailExt;
    property OnEvaluationDoneExt : TIQsEventsOnEvaluationDoneExtEvent read FOnEvaluationDoneExt write FOnEvaluationDoneExt;
    property OnStatisticalAlarmExt : TIQsEventsOnStatisticalAlarmExtEvent read FOnStatisticalAlarmExt write FOnStatisticalAlarmExt;
    property OnSystemAlarmExt : TIQsEventsOnSystemAlarmExtEvent read FOnSystemAlarmExt write FOnSystemAlarmExt;
    property OnQueryOpen : TIQsEventsOnQueryOpenEvent read FOnQueryOpen write FOnQueryOpen;
    property OnStatisticalAlarmExtVA : TIQsEventsOnStatisticalAlarmExtVAEvent read FOnStatisticalAlarmExtVA write FOnStatisticalAlarmExtVA;
    property OnApplicationClose : TIQsEventsOnApplicationCloseEvent read FOnApplicationClose write FOnApplicationClose;
    property OnDataSourceBeforeClose : TIQsEventsOnDataSourceBeforeCloseEvent read FOnDataSourceBeforeClose write FOnDataSourceBeforeClose;
    property OnSavingDone : TIQsEventsOnSavingDoneEvent read FOnSavingDone write FOnSavingDone;
  end;

  //SinkIntfEnd//

procedure Register;

implementation

uses
  SysUtils
  ;

{ globals }

procedure BuildPositionalDispIds (pDispIds : PDispIdList; const dps : TDispParams);
var
  i : integer;
begin
  Assert (pDispIds <> NIL);
  
  { by default, directly arrange in reverse order }
  for i := 0 to dps.cArgs - 1 do
    pDispIds^[i] := dps.cArgs - 1 - i;

  { check for named args }
  if (dps.cNamedArgs <= 0) then Exit;

  { parse named args }
  for i := 0 to dps.cNamedArgs - 1 do
    pDispIds^ [dps.rgdispidNamedArgs^ [i]] := i;
end;


{ TQs_statEventsBaseSink }

function TQs_statEventsBaseSink.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TQs_statEventsBaseSink.GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
  pointer (TypeInfo) := NIL;
end;

function TQs_statEventsBaseSink.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
  Count := 0;
end;

function TQs_statEventsBaseSink.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
var
  dps : TDispParams absolute Params;
  bHasParams : boolean;
  pDispIds : PDispIdList;
  iDispIdsSize : integer;
begin
  { validity checks }
  if (Flags AND DISPATCH_METHOD = 0) then
    raise Exception.Create (
      Format ('%s only supports sinking of method calls!', [ClassName]
    ));

  { build pDispIds array. this maybe a bit of overhead but it allows us to
    sink named-argument calls such as Excel's AppEvents, etc!
  }
  pDispIds := NIL;
  iDispIdsSize := 0;
  bHasParams := (dps.cArgs > 0);
  if (bHasParams) then
  begin
    iDispIdsSize := dps.cArgs * SizeOf (TDispId);
    GetMem (pDispIds, iDispIdsSize);
  end;  { if }

  try
    { rearrange dispids properly }
    if (bHasParams) then BuildPositionalDispIds (pDispIds, dps);
    Result := DoInvoke (DispId, IID, LocaleID, Flags, dps, pDispIds, VarResult, ExcepInfo, ArgErr);
  finally
    { free pDispIds array }
    if (bHasParams) then FreeMem (pDispIds, iDispIdsSize);
  end;  { finally }
end;

function TQs_statEventsBaseSink.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  Result := E_NOINTERFACE;
  pointer (Obj) := NIL;
  if (GetInterface (IID, Obj)) then Result := S_OK;
  if not Succeeded (Result) then
    if (IsEqualIID (IID, FSinkIID)) then
      if (GetInterface (IDispatch, Obj)) then
        Result := S_OK;
end;

function TQs_statEventsBaseSink._AddRef: Integer;
begin
  Result := 2;
end;

function TQs_statEventsBaseSink._Release: Integer;
begin
  Result := 1;
end;

destructor TQs_statEventsBaseSink.Destroy;
begin
  Disconnect;
  inherited;
end;

procedure TQs_statEventsBaseSink.Connect (pSource : IUnknown);
var
  pcpc : IConnectionPointContainer;
begin
  Assert (pSource <> NIL);
  Disconnect;
  try
    OleCheck (pSource.QueryInterface (IConnectionPointContainer, pcpc));
    OleCheck (pcpc.FindConnectionPoint (FSinkIID, FCP));
    OleCheck (FCP.Advise (Self, FCookie));
    FSource := pSource;
  except
    raise Exception.Create (Format ('Unable to connect %s.'#13'%s', [Name, Exception (ExceptObject).Message]));
  end;  { finally }
end;

procedure TQs_statEventsBaseSink.Disconnect;
begin
  if (FSource = NIL) then Exit;
  try
    OleCheck (FCP.Unadvise (FCookie));
    FCP := NIL;
    FSource := NIL;
  except
    pointer (FCP) := NIL;
    pointer (FSource) := NIL;
  end;  { except }
end;


//SinkImplStart//

function TIQsEvents.DoInvoke (DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var dps : TDispParams; pDispIds : PDispIdList;
  VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  POleVariant = ^OleVariant;
begin
  Result := DISP_E_MEMBERNOTFOUND;

  //SinkInvoke//
  //SinkInvokeEnd//
end;

constructor TIQsEvents.Create (pOwner : TComponent);
begin
  inherited Create (pOwner);
  //SinkInit//
  FSinkIID := IQsEvents;
  hEvaluationEvent := CreateEvent(nil, False,(*true, {manual reset}*) false,'nix');
  hDataAvailEvent := CreateEvent(nil, False, False, 'hallo');
  hQueryOpenEvent := CreateEvent(nil, False, False, 'hallo1');
  InitializeCriticalSection( CS_DATAVAIL);
end;


destructor TIQsEvents.Destroy;
begin
  DeleteCriticalSection( CS_DATAVAIL);

  CloseHandle(hEvaluationEvent);
  CloseHandle(hDataAvailEvent);
  CloseHandle(hQueryOpenEvent);
  inherited Destroy;
end;

//SinkImplementation//
function  TIQsEvents.DoOnGetAliveState(out state: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnGetAliveState) then Exit;
  Result := OnGetAliveState (Self, state);
end;

function  TIQsEvents.DoOnDataAvail(NumOfChars: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnDataAvail) then Exit;
  inc(FDataCount);
  SetEvent(hDataAvailEvent);
  OnDataAvail (Self, NumOfChars);
end;


function  TIQsEvents.DoOnQSSTATInitialized: HResult;
begin
  Result := S_OK;
  if not Assigned (OnQSSTATInitialized) then Exit;
  Result := OnQSSTATInitialized (Self);
end;

function TIQsEvents.DoOnEvaluationDone: HResult;
begin
  Result := S_OK;
  if not Assigned (OnEvaluationDone) then Exit;
  // set the event for waiting application (evaluation)
  inc(FEvalCount);
  SetEvent(hEvaluationEvent);
  OnEvaluationDone (Self);
end;

function  TIQsEvents.DoOnError(ErrorCode: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnError) then Exit;
  Result := OnError (Self, ErrorCode);
end;

function  TIQsEvents.DoOnStatisticalAlarm(Alarm_EW_1: LongWord; Alarm_EW_2: LongWord; Alarm_QRK_L: LongWord; Alarm_QRK_S: LongWord; Alarm_CP: LongWord; Alarm_NO_SPC: LongWord; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnStatisticalAlarm) then Exit;
  Result := OnStatisticalAlarm (Self, Alarm_EW_1, Alarm_EW_2, Alarm_QRK_L, Alarm_QRK_S, Alarm_CP, Alarm_NO_SPC, Part_Nr, Char_Nr, Value_Nr, Sample_Nr);
end;

function  TIQsEvents.DoOnSystemAlarm(AlarmCode: LongWord): HResult;
begin
  Result := S_OK;
  if not Assigned (OnSystemAlarm) then Exit;
  Result := OnSystemAlarm (Self, AlarmCode);
end;

function  TIQsEvents.DoOnUploadProgress(UploadChildHandle: Integer; UploadState: Integer; const filename: WideString; FileNo: Integer; NumOfFiles: Integer; PartNo: Integer; const PartKey: WideString; CharNo: Integer; const CharKey: WideString; NumOfChars: Integer; ValueNo: Integer; NumOfValues: Integer; ErrorNo: Integer; const ErrorMsg: WideString; TimeStamp: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnUploadProgress) then Exit;
  Result := OnUploadProgress (Self, UploadChildHandle, UploadState, filename, FileNo, NumOfFiles, PartNo, PartKey, CharNo, CharKey, NumOfChars, ValueNo, NumOfValues, ErrorNo, ErrorMsg, TimeStamp);
end;

function  TIQsEvents.DoOnDataAvailExt(handle: Integer; NumOfChars: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnDataAvailExt) then Exit;
  EnterCriticalSection( CS_DATAVAIL);

  Result := OnDataAvailExt (Self, handle, NumOfChars);
  LeaveCriticalSection( CS_DATAVAIL);
end;

function  TIQsEvents.DoOnEvaluationDoneExt(handle: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnEvaluationDoneExt) then Exit;
  Result := OnEvaluationDoneExt (Self, handle);
end;

function  TIQsEvents.DoOnStatisticalAlarmExt(handle: Integer; Alarm_EW_1: LongWord; Alarm_EW_2: LongWord; Alarm_QRK_L: LongWord; Alarm_QRK_S: LongWord; Alarm_CP: LongWord; Alarm_NO_SPC: LongWord; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnStatisticalAlarmExt) then Exit;
  Result := OnStatisticalAlarmExt (Self, handle, Alarm_EW_1, Alarm_EW_2, Alarm_QRK_L, Alarm_QRK_S, Alarm_CP, Alarm_NO_SPC, Part_Nr, Char_Nr, Value_Nr, Sample_Nr);
end;

function  TIQsEvents.DoOnSystemAlarmExt(handle: Integer; AlarmCode: LongWord): HResult;
begin
  Result := S_OK;
  if not Assigned (OnSystemAlarmExt) then Exit;
  Result := OnSystemAlarmExt (Self, handle, AlarmCode);
end;

function  TIQsEvents.DoOnQueryOpen(handle: Integer; QueryHandle: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnQueryOpen) then Exit;
  Result := OnQueryOpen (Self, handle, QueryHandle);
end;

function  TIQsEvents.DoOnStatisticalAlarmExtVA(handle: Integer; Alarm_EW_1: OleVariant; Alarm_EW_2: OleVariant; Alarm_QRK_L: OleVariant; Alarm_QRK_S: OleVariant; Alarm_CP: OleVariant; Alarm_NO_SPC: OleVariant; Part_Nr: Integer; Char_Nr: Integer; Value_Nr: Integer; Sample_Nr: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnStatisticalAlarmExtVA) then Exit;
  Result := OnStatisticalAlarmExtVA (Self, handle, Alarm_EW_1, Alarm_EW_2, Alarm_QRK_L, Alarm_QRK_S, Alarm_CP, Alarm_NO_SPC, Part_Nr, Char_Nr, Value_Nr, Sample_Nr);
end;

function  TIQsEvents.DoOnApplicationClose(var Accept: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnApplicationClose) then Exit;
  Result := OnApplicationClose (Self, Accept);
end;

function  TIQsEvents.DoOnDataSourceBeforeClose(handle: Integer; DataSourceType: Integer; const name: WideString;var Accept: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnDataSourceBeforeClose) then Exit;
  Result := OnDataSourceBeforeClose (Self,handle, DataSourceType,name,Accept);
end;

function  TIQsEvents.DoOnSavingDone(handle: Integer): HResult;
begin
  Result := S_OK;
  if not Assigned (OnSavingDone) then Exit;
  Result := OnSavingDone (Self, handle);
end;



//SinkImplEnd//

procedure Register;
begin
  //SinkRegisterStart//
  RegisterComponents ('ActiveX', [TIQsEvents]);
  //SinkRegisterEnd//
end;

end.
