VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form AppendTextDlg 
   Caption         =   "Online Server transmition"
   ClientHeight    =   4905
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   5895
   LinkTopic       =   "Form12"
   ScaleHeight     =   4905
   ScaleWidth      =   5895
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Transmit text"
      Height          =   2415
      Left            =   120
      TabIndex        =   10
      Top             =   1680
      Width           =   5655
      Begin VB.CheckBox CB_Transmit_6 
         Caption         =   "TransmitFileExt(h, 6, 0)"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   2040
         Width           =   3255
      End
      Begin VB.CommandButton BB_ApplyText 
         Caption         =   "Apply"
         Height          =   375
         Left            =   4200
         TabIndex        =   12
         Top             =   1920
         Width           =   1215
      End
      Begin VB.TextBox AppendText 
         Height          =   1455
         Left            =   240
         MultiLine       =   -1  'True
         TabIndex        =   11
         Top             =   360
         Width           =   5175
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Data File"
      Height          =   735
      Left            =   120
      TabIndex        =   6
      Top             =   840
      Width           =   5655
      Begin VB.TextBox ED_DFXFile 
         Enabled         =   0   'False
         Height          =   285
         Left            =   120
         Locked          =   -1  'True
         TabIndex        =   9
         Top             =   240
         Width           =   3375
      End
      Begin VB.CommandButton BB_OpenDFX 
         Caption         =   "..."
         Height          =   255
         Left            =   3600
         TabIndex        =   8
         Top             =   240
         Width           =   375
      End
      Begin VB.CommandButton BB_ApplyDFX 
         Caption         =   "Apply"
         Height          =   375
         Left            =   4200
         TabIndex        =   7
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Frame FA_File 
      Caption         =   "Head File"
      Height          =   735
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   5655
      Begin VB.CommandButton BB_ApplyDFD 
         Caption         =   "Apply"
         Height          =   375
         Left            =   4200
         TabIndex        =   5
         Top             =   240
         Width           =   1215
      End
      Begin VB.CommandButton BB_OpenDFD 
         Caption         =   "..."
         Height          =   255
         Left            =   3600
         TabIndex        =   4
         Top             =   240
         Width           =   375
      End
      Begin VB.TextBox ED_DFDFile 
         Enabled         =   0   'False
         Height          =   285
         Left            =   120
         Locked          =   -1  'True
         TabIndex        =   3
         Top             =   240
         Width           =   3375
      End
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   4320
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   1680
      TabIndex        =   0
      Top             =   4320
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog OpenFileDialog 
      Left            =   240
      Top             =   5160
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "AppendTextDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public FileName As String

Private Sub OKButton_Click()
  Me.Hide
End Sub

Private Sub CancelButton_Click()
  Me.Hide
End Sub

Private Sub BB_OpenDFD_Click()
  'predefine file name
   FileName = ""
  'presetting file dialog adjustments
  OpenFileDialog.DialogTitle = "Open qs-STAT file"
  OpenFileDialog.InitDir = "c:\q-das\qsstat_me\tests\"
  OpenFileDialog.Filter = "QS-STAT files (*.dfq)|*.dfq|QS-STAT files (*.dfd)|*.dfd"
  OpenFileDialog.FilterIndex = 2
  FileName = OpenFileDialog.FileName
  OpenFileDialog.ShowOpen
  ED_DFDFile.Text = OpenFileDialog.FileName
End Sub

Private Sub BB_OpenDFX_Click()
  'predefine file name
   FileName = ""
  'presetting file dialog adjustments
  OpenFileDialog.DialogTitle = "Open qs-STAT file"
  OpenFileDialog.InitDir = "c:\q-das\qsstat_me\tests\"
  OpenFileDialog.Filter = "QS-STAT files (*.dfx)|*.dfx"
  OpenFileDialog.FilterIndex = 1
  FileName = OpenFileDialog.FileName
  OpenFileDialog.ShowOpen
  ED_DFXFile.Text = OpenFileDialog.FileName
End Sub

Private Sub BB_ApplyDFD_Click()
  If ED_DFDFile.Text <> "" Then
    VBCOMClient2.FileName = ED_DFDFile.Text
    Call VBCOMClient2.TransmitFile(0, _
                                   GetArrayFromFile(VBCOMClient2.FileName), _
                                   True)
  End If
End Sub

Private Sub BB_ApplyDFX_Click()
  Dim Param As Integer
  Param = 2
  If CB_Transmit_6.value = 1 Then
    Param = 6
  End If
  Call VBCOMClient2.TransmitFile(Param, _
                                 GetArrayFromFile(ED_DFXFile.Text), _
                                 True)
End Sub

Private Sub BB_ApplyText_Click()
  Dim Param As Integer
  Param = 2
  If CB_Transmit_6.value = 1 Then
    Param = 6
  End If
  Call VBCOMClient2.TransmitFile(Param, _
                                 GetArrayFromString(AppendText.Text), _
                                 True)
End Sub

'-------------------------------------------------------------------------------------------
' Get Array from Text
'-------------------------------------------------------------------------------------------

Function GetArrayFromString(Text As String) As Variant
  Dim Str As String
  Dim DataStream As Variant
  Dim i As Long
    
  Str = Text + vbCrLf
    
  ReDim DataStream(Len(Str) + 2) As Byte
  For i = 1 To Len(Str)
    DataStream(i - 1) = Asc(Mid$(Str, i, 1))
  Next i
  
  DataStream(Len(Str) + 1) = 13
  DataStream(Len(Str) + 2) = 10
  
  VBCOMClient2.FileName = ""
  
  GetArrayFromString = DataStream
End Function

'-------------------------------------------------------------------------------------------
' Get Array from File
'-------------------------------------------------------------------------------------------

Function GetArrayFromFile(FileName As String) As Variant
  Dim Stream()  As Byte
  Dim filenum   As Integer
  Dim filelen   As Long
  If FileName <> "" Then

    '<-open file for Write
    filenum = FreeFile
    
    Open FileName For Binary As #filenum
    filelen = LOF(filenum) - 1
        
    ReDim Stream(filelen + 2)
        
    Get #filenum, 1, Stream
                
    Close #filenum
  
    Stream(filelen + 1) = 13
    Stream(filelen + 2) = 10
  
    GetArrayFromFile = Stream
  End If
End Function

