VERSION 5.00
Begin VB.Form ENUMDlg 
   Caption         =   "Data Base - Select Query"
   ClientHeight    =   1515
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   4200
   LinkTopic       =   "Form1"
   ScaleHeight     =   1515
   ScaleWidth      =   4200
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame FA_DB 
      Height          =   735
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   3975
      Begin VB.ComboBox COB_ENUM 
         Height          =   315
         Left            =   960
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   240
         Width           =   2895
      End
      Begin VB.Label LA_Text 
         AutoSize        =   -1  'True
         Caption         =   "DB:"
         Height          =   195
         Left            =   120
         TabIndex        =   4
         Top             =   360
         Width           =   270
      End
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2160
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   960
      Width           =   1215
   End
End
Attribute VB_Name = "ENUMDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim DBSelNameList(50) As String

Sub SetENUM(Action As Integer)
  VBCOMClient2.ActionSelector = Action
  Select Case Action
    Case 1
      SetModule
    Case 2
      SetLanguage
    Case 3
      SetStrategy
    Case 4
      SetPrinter
    Case 5
      SetDB
  End Select
End Sub

Private Sub OKButton_Click()
   Select Case VBCOMClient2.ActionSelector
    Case 1
      GetModule
    Case 2
      GetLanguage
    Case 3
      GetStrategy
    Case 4
      GetPrinter
    Case 5
      GetDBSelction
      VBCOMClient2.DBOpen
  End Select
  Me.Hide
End Sub

Private Sub CancelButton_Click()
  Me.Hide
End Sub

'-------------------------------------------------------------------------------------------
' Set-> Module
'-------------------------------------------------------------------------------------------

Sub SetModule()
  Dim IqsSTATModule As IEnumModule
  Dim ModuleName As String
  Dim ModuleKey As Long
  Dim i As Integer

  ENUMDlg.Caption = "Set Module"
  ENUMDlg.LA_Text.Caption = "Module"
  
  '<- get interface ->
  Set IqsSTATModule = VBCOMClient2.qsstat
  
  '<- predefine variables  ->
  i = 0
  ModuleKey = 0
  ModuleName = ""
  
  '<- clearing combo ->
  COB_ENUM.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATModule.GetFirstModule(VBCOMClient2.qsstatHandle, ModuleKey, ModuleName)
  
  Do While -1
    COB_ENUM.List(i) = ModuleName + " (" + CStr(ModuleKey) + ")"
    COB_ENUM.ItemData(i) = ModuleKey
    Call IqsSTATModule.GetNextModule(VBCOMClient2.qsstatHandle, ModuleKey, ModuleName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop

ErrorHandler:
  
  If COB_ENUM.ListCount > 0 Then
    '<- set default element as selected if any ->
    For i = 0 To COB_ENUM.ListCount - 1
      If COB_ENUM.ItemData(i) = VBCOMClient2.qs_Module Then
        COB_ENUM.ListIndex = i
      End If
    Next
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Get-> Module
'-------------------------------------------------------------------------------------------
Public Sub GetModule()
  '<- get selected module ->
  If COB_ENUM.ListCount > 0 Then
    VBCOMClient2.qs_Module = COB_ENUM.ItemData(COB_ENUM.ListIndex)
    '<- set new module ->
    On Error GoTo ErrorHandler
    Call VBCOMClient2.qsstat.SetModule(VBCOMClient2.qsstatHandle, _
                                       VBCOMClient2.qs_Module)
  End If
ErrorHandler:

End Sub

'-------------------------------------------------------------------------------------------
' Set-> Language
'-------------------------------------------------------------------------------------------
Sub SetLanguage()
  Dim IqsSTATLanguage As IEnumLanguage
  Dim LanguageName As String
  Dim LanguageShortName As String
  Dim LanguageKey As Long
  Dim i As Integer
  
  ENUMDlg.Caption = "Set Language"
  ENUMDlg.LA_Text.Caption = "Language"
       
  '<- get interface ->
  Set IqsSTATLanguage = VBCOMClient2.qsstat
  
  '<- predefine variables  ->
  i = 0
  LanguageKey = 0
  LanguageName = ""
  
  '<- clearing combo ->
  COB_ENUM.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATLanguage.GetFirstLanguage(VBCOMClient2.qsstatHandle, _
                                        LanguageName, _
                                        LanguageShortName, _
                                        LanguageKey)
  
  Do While -1
    COB_ENUM.List(i) = LanguageName + " (" + CStr(LanguageKey) + ")"
    COB_ENUM.ItemData(i) = LanguageKey
    Call IqsSTATLanguage.GetNextLanguage(VBCOMClient2.qsstatHandle, _
                                         LanguageName, _
                                         LanguageShortName, _
                                         LanguageKey)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop

ErrorHandler:
  
  If COB_ENUM.ListCount > 1 Then
    '<- set default element as selected if any ->
    For i = 0 To COB_ENUM.ListCount - 1
      If COB_ENUM.ItemData(i) = VBCOMClient2.qs_Language Then
        COB_ENUM.ListIndex = i
      End If
    Next
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Get-> Language
'-------------------------------------------------------------------------------------------
Private Sub GetLanguage()
  Dim LangName As String
  If COB_ENUM.ListCount > 0 Then
    If COB_ENUM.ItemData(COB_ENUM.ListIndex) <> VBCOMClient2.qs_Language Then
      '<- get selected language ->
      VBCOMClient2.qs_Language = COB_ENUM.ItemData(COB_ENUM.ListIndex)
      '<- set new language ->
      On Error GoTo ErrorHandler
      Call VBCOMClient2.qsstat.SetLanguage(VBCOMClient2.qsstatHandle, _
                                           VBCOMClient2.qs_Language, _
                                           LangName)
    End If
  End If
ErrorHandler:

End Sub

'-------------------------------------------------------------------------------------------
' Set-> Strategy
'-------------------------------------------------------------------------------------------
Sub SetStrategy()
  Dim IqsSTATStrategy As IEnumEvaluationStrategy
  Dim StrategyName As String
  Dim StrategyKey As Long
  Dim i As Integer
  
  ENUMDlg.Caption = "Set Evaluation Strategy"
  ENUMDlg.LA_Text.Caption = "Strategy"
  
  '<- get interface ->
  Set IqsSTATStrategy = VBCOMClient2.qsstat
  
  '<- predefine variables  ->
  i = 0
  StrategyKey = 0
  StrategyName = ""
  
  '<- clearing combo ->
  COB_ENUM.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATStrategy.GetFirstEvaluationStrategy(VBCOMClient2.qsstatHandle, _
                                                  VBCOMClient2.qs_Module, _
                                                  0, _
                                                  StrategyKey, _
                                                  StrategyName)
  
  Do While -1
    COB_ENUM.List(i) = StrategyName + " (" + CStr(StrategyKey) + ")"
    COB_ENUM.ItemData(i) = StrategyKey
    Call IqsSTATStrategy.GetNextEvaluationStrategy(VBCOMClient2.qsstatHandle, _
                                                   VBCOMClient2.qs_Module, _
                                                   0, _
                                                   StrategyKey, _
                                                   StrategyName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop
    
ErrorHandler:

  If COB_ENUM.ListCount > 1 Then
    '<- set default element as selected if any ->
    For i = 0 To COB_ENUM.ListCount - 1
      If COB_ENUM.ItemData(i) = VBCOMClient2.qs_Strategy Then
        COB_ENUM.ListIndex = i
      End If
    Next
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Get-> Strategy
'-------------------------------------------------------------------------------------------
Private Sub GetStrategy()
  If COB_ENUM.ListIndex > 0 Then
    If COB_ENUM.ItemData(COB_ENUM.ListIndex) <> VBCOMClient2.qs_Strategy Then
      '<- get selected strategy ->
      VBCOMClient2.qs_Strategy = COB_ENUM.ItemData(COB_ENUM.ListIndex)
      '<- set new strategy ->
      On Error GoTo ErrorHandler
      Call VBCOMClient2.qsstat.SetEvaluationStrategy(VBCOMClient2.qsstatHandle, _
                                                     0, _
                                                     VBCOMClient2.qs_Strategy)
    End If
  End If
ErrorHandler:

End Sub

'-------------------------------------------------------------------------------------------
' Set-> Printer
'-------------------------------------------------------------------------------------------
Sub SetPrinter()
  Dim IqsSTATPrinter As IEnumPrinter
  Dim PrinterKey As Long
  Dim PrinterName As String
  Dim i As Integer
  
  ENUMDlg.Caption = "Set Printer"
  ENUMDlg.LA_Text.Caption = "Printer"
  
  '<- get interface ->
  Set IqsSTATPrinter = VBCOMClient2.qsstat
  
  '<- predefine variables  ->
  i = 0
  PrinterKey = 0
  PrinterName = ""
  
  '<- clearing combo ->
  COB_ENUM.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATPrinter.GetFirstPrinter(VBCOMClient2.qsstatHandle, _
                                      PrinterKey, _
                                      PrinterName)
  
  Do While -1
    COB_ENUM.List(i) = PrinterName + " (" + CStr(PrinterKey) + ")"
    COB_ENUM.ItemData(i) = PrinterKey
    Call IqsSTATPrinter.GetNextPrinter(VBCOMClient2.qsstatHandle, _
                                       PrinterKey, _
                                       PrinterName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop
    
ErrorHandler:

  If COB_ENUM.ListCount > 1 Then
    '<- set default element as selected if any ->
    For i = 0 To COB_ENUM.ListCount - 1
      If COB_ENUM.ItemData(i) = VBCOMClient2.qs_Printer Then
        COB_ENUM.ListIndex = i
      End If
    Next
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Get-> Printer
'-------------------------------------------------------------------------------------------
Private Sub GetPrinter()
  If COB_ENUM.ListIndex > 0 Then
    If COB_ENUM.ItemData(COB_ENUM.ListIndex) <> VBCOMClient2.qs_Printer Then
      '<- get selected strategy ->
      VBCOMClient2.qs_Printer = COB_ENUM.ItemData(COB_ENUM.ListIndex)
    End If
  End If
ErrorHandler:

End Sub

'-------------------------------------------------------------------------------------------
' Set-> DB
'-------------------------------------------------------------------------------------------
Private Sub SetDB()
  Dim IqsSTATDBSelectionName As IEnumDBSelectionName
  Dim DBSelectName As String
  Dim i As Integer
  
  ENUMDlg.Caption = "Date Base - Select Query"
  ENUMDlg.LA_Text.Caption = "DB"
  
  '<- get interface ->
  Set IqsSTATDBSelectionName = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  i = 0
  DBSelectName = ""
  
  '<- clearing combo ->
  COB_ENUM.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATDBSelectionName.GetFirstDBSelection(VBCOMClient2.qsstatHandle, _
                                                  DBSelectName)
  Do While -1
    COB_ENUM.List(i) = DBSelectName
    DBSelNameList(i) = DBSelectName
    COB_ENUM.ItemData(i) = i
    Call IqsSTATDBSelectionName.GetNextDBSelection(VBCOMClient2.qsstatHandle, _
                                                   DBSelectName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop
  
ErrorHandler:
  
  '<- set first element of list by default selected ->
  
End Sub

'-------------------------------------------------------------------------------------------
' Get-> DB
'-------------------------------------------------------------------------------------------
Private Function GetDBSelction() As String

  On Error GoTo ErrorHandler
  If COB_ENUM.ListIndex >= 0 Then
    VBCOMClient2.qs_DBSelName = DBSelNameList(COB_ENUM.ListIndex)
  End If
  
ErrorHandler:

End Function
