VERSION 5.00
Begin VB.Form LoginDlg 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Login"
   ClientHeight    =   2580
   ClientLeft      =   2835
   ClientTop       =   3480
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1524.349
   ScaleMode       =   0  'User
   ScaleWidth      =   4971.719
   ShowInTaskbar   =   0   'False
   Begin VB.Frame FA_Settings 
      Height          =   1875
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   5130
      Begin VB.ComboBox COB_User 
         Height          =   315
         Left            =   1680
         TabIndex        =   10
         Top             =   240
         Width           =   3330
      End
      Begin VB.ComboBox COB_Language 
         Height          =   315
         Left            =   1680
         TabIndex        =   8
         Top             =   1320
         Width           =   3330
      End
      Begin VB.ComboBox COB_Module 
         Height          =   315
         Left            =   1680
         TabIndex        =   7
         Top             =   960
         Width           =   3330
      End
      Begin VB.TextBox ED_PWD 
         Height          =   285
         IMEMode         =   3  'DISABLE
         Left            =   1680
         PasswordChar    =   "*"
         TabIndex        =   3
         Top             =   600
         Width           =   3330
      End
      Begin VB.Label lblLabels 
         Caption         =   "User Name:"
         Height          =   270
         Index           =   0
         Left            =   255
         TabIndex        =   9
         Top             =   300
         Width           =   1065
      End
      Begin VB.Label lblLabels 
         Caption         =   "Language:"
         Height          =   270
         Index           =   3
         Left            =   255
         TabIndex        =   6
         Top             =   1365
         Width           =   1065
      End
      Begin VB.Label lblLabels 
         Caption         =   "Module:"
         Height          =   270
         Index           =   2
         Left            =   255
         TabIndex        =   5
         Top             =   1005
         Width           =   1065
      End
      Begin VB.Label lblLabels 
         Caption         =   "Password:"
         Height          =   270
         Index           =   1
         Left            =   240
         TabIndex        =   4
         Top             =   645
         Width           =   1065
      End
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   372
      Left            =   1560
      TabIndex        =   0
      Top             =   2040
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   372
      Left            =   2880
      TabIndex        =   1
      Top             =   2040
      Width           =   1065
   End
End
Attribute VB_Name = "LoginDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCancel_Click()
    Me.Hide
    VBCOMClient2.ConnectServer
End Sub

Private Sub cmdOK_Click()
  Me.Hide
  VBCOMClient2.ConnectServer
End Sub

Private Sub Form_Load()
  ED_PWD = "superuser"
  SetUser
  SetModule
  SetLanguage
End Sub

'-------------------------------------------------------------------------------------------
' Set COMBO -> User
'-------------------------------------------------------------------------------------------

Private Sub SetUser()

  Dim UserName As String
  Dim i As Integer

    '<- get interface ->
    Set VBCOMClient2.IqsSTATUser = VBCOMClient2.qsstat
    
    '<- predefine variables  ->

    i = 0
    UserName = ""

    '<- clearing combo ->
    COB_User.Clear
  
    '<- put data in to combo ->
    On Error GoTo ErrorHandler
    Call VBCOMClient2.IqsSTATUser.GetFirstUser(UserName)
    Do While -1
      COB_User.List(i) = UserName
      COB_User.ItemData(i) = CStr(i)
      Call VBCOMClient2.IqsSTATUser.GetNextUser(UserName)
      On Error GoTo ErrorHandler
      i = i + 1
    Loop

ErrorHandler:
  
    COB_User.ListIndex = 0
End Sub

'-------------------------------------------------------------------------------------------
' Set COMBO -> Module
'-------------------------------------------------------------------------------------------

Private Sub SetModule()
  Dim IqsSTATModule As IEnumModule
  Dim ModuleName As String
  Dim ModuleKey As Long
  Dim i As Integer
  
  '<- get interface ->
  Set IqsSTATModule = VBCOMClient2.qsstat
  
  '<- predefine variables ->
  i = 0
  ModuleKey = 0
  ModuleName = ""
  
  '<- clearing combo ->
  COB_Module.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATModule.GetFirstModule(VBCOMClient2.qsstatHandle, _
                                    ModuleKey, _
                                    ModuleName)
  
  Do While -1
    COB_Module.List(i) = ModuleName + " (" + CStr(ModuleKey) + ")"
    COB_Module.ItemData(i) = ModuleKey
    Call IqsSTATModule.GetNextModule(VBCOMClient2.qsstatHandle, _
                                     ModuleKey, _
                                     ModuleName)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop

ErrorHandler:
  
  If COB_Module.ListCount > 0 Then
    '<- set default element as selected if any ->
    For i = 0 To COB_Module.ListCount - 1
      If COB_Module.ItemData(i) = VBCOMClient2.qs_Module Then
        COB_Module.ListIndex = i
      End If
    Next
  Else
    '<- set first element of list by default selected ->
    COB_Module.ListIndex = 0
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Set COMBO -> Language
'-------------------------------------------------------------------------------------------

Sub SetLanguage()
  Dim IqsSTATLanguage As IEnumLanguage
  Dim LanguageName As String
  Dim LanguageShortName As String
  Dim LanguageKey As Long
  Dim i As Integer
       
  '<- get interface ->
  Set IqsSTATLanguage = VBCOMClient2.qsstat
  
  '<- predefine variables  ->
  i = 0
  LanguageKey = 0
  LanguageName = ""
  
  '<- clearing combo ->
  COB_Language.Clear
  
  '<- put data in to combo ->
  On Error GoTo ErrorHandler
  Call IqsSTATLanguage.GetFirstLanguage(VBCOMClient2.qsstatHandle, _
                                        LanguageName, _
                                        LanguageShortName, _
                                        LanguageKey)
  
  Do While -1
    COB_Language.List(i) = LanguageName + " (" + CStr(LanguageKey) + ")"
    COB_Language.ItemData(i) = LanguageKey
    Call IqsSTATLanguage.GetNextLanguage(VBCOMClient2.qsstatHandle, _
                                         LanguageName, _
                                         LanguageShortName, _
                                         LanguageKey)
    On Error GoTo ErrorHandler
    i = i + 1
  Loop

ErrorHandler:
  
  'presetting current QS_STAT Language on top
  If COB_Language.ListCount > 1 Then
    For i = 0 To COB_Language.ListCount - 1
      If COB_Language.ItemData(i) = VBCOMClient2.qs_Language Then
        COB_Language.ListIndex = i
      End If
    Next
  End If
End Sub

'-------------------------------------------------------------------------------------------
' Get COMBO -> Module
'-------------------------------------------------------------------------------------------
Private Sub COB_Module_Click()
  '<- get selected module ->
  VBCOMClient2.qs_Module = COB_Module.ItemData(COB_Module.ListIndex)
End Sub

'-------------------------------------------------------------------------------------------
' Get COMBO -> Language
'-------------------------------------------------------------------------------------------
Private Sub COB_Language_Click()
  '<- get selected language ->
  VBCOMClient2.qs_Language = COB_Language.ItemData(COB_Language.ListIndex)
End Sub
