// AlarmShowDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient1.h"
#include "AlarmShowDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlarmShowDlg dialog


CAlarmShowDlg::CAlarmShowDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAlarmShowDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAlarmShowDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	pAlarmList  = NULL;
}


void CAlarmShowDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlarmShowDlg)
	DDX_Control(pDX, IDC_ALARMLISTVIEW, m_AlarmListView);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlarmShowDlg, CDialog)
	//{{AFX_MSG_MAP(CAlarmShowDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlarmShowDlg message handlers

void CAlarmShowDlg::SetAlarmList(CArray<CAlarm, CAlarm>* p)
{
	pAlarmList = p;
}

BOOL CAlarmShowDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_AlarmListView.InsertColumn(0,"Part",LVCFMT_LEFT,50);
	m_AlarmListView.InsertColumn(1,"Char",LVCFMT_LEFT,50);
	m_AlarmListView.InsertColumn(2,"Value",LVCFMT_LEFT,50);
	m_AlarmListView.InsertColumn(3,"EW1",LVCFMT_LEFT,50);
	m_AlarmListView.InsertColumn(4,"QCC-L",LVCFMT_LEFT,50);
	m_AlarmListView.InsertColumn(5,"QCC-V",LVCFMT_LEFT,50);
	
	for (int i = 0; i < pAlarmList->GetSize();i++)
	{
		CAlarm	Alarm;
		CString	s;
		Alarm = pAlarmList->GetAt(i);
		s.Format("%d",Alarm.PartNr);
		m_AlarmListView.InsertItem(i,s,0);

		s.Format("%d",Alarm.CharNr);
		m_AlarmListView.SetItem(i,1,LVIF_TEXT,s,0,0,0,0);

		s.Format("%d",Alarm.ValueNr);
		m_AlarmListView.SetItem(i,2,LVIF_TEXT,s,0,0,0,0);

		s.Format("%d",Alarm.AlarmEW1);
		m_AlarmListView.SetItem(i,3,LVIF_TEXT,s,0,0,0,0);

		s.Format("%d",Alarm.AlarmQRK_l);
		m_AlarmListView.SetItem(i,4,LVIF_TEXT,s,0,0,0,0);

		s.Format("%d",Alarm.AlarmQRK_s);
		m_AlarmListView.SetItem(i,5,LVIF_TEXT,s,0,0,0,0);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

