// SelektGrafKey.cpp : implementation file
//
#include "stdafx.h"
#include "VCPPCOMClient1.h"
#include "SelektGrafKey.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektGrafKey dialog

CSelektGrafKey::CSelektGrafKey(CWnd* pParent /*=NULL*/)   // standard constructor
: CDialog(CSelektGrafKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektGrafKey)
	m_CharNr_x = 0;
	m_CharNr_y = 0;
	m_GrafKey = 0;
	m_PartNr_x = 0;
	m_PartNr_y = 0;
	m_GrafSubKey = 0;
	m_Graphic = -1;
	m_Part = 1;
	m_Char = 1;
	m_UseExtFunc = FALSE;
	//}}AFX_DATA_INIT
}


void CSelektGrafKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektGrafKey)
	DDX_Text(pDX, IDC_ED_Char_x, m_CharNr_x);
	DDX_Text(pDX, IDC_ED_Char_y, m_CharNr_y);
	DDX_Text(pDX, IDC_ED_Key, m_GrafKey);
	DDX_Text(pDX, IDC_ED_Part_x, m_PartNr_x);
	DDX_Text(pDX, IDC_ED_Part_y, m_PartNr_y);
	DDX_Text(pDX, IDC_ED_SubKey, m_GrafSubKey);
	DDX_Check(pDX, IDC_UseExtFunc, m_UseExtFunc);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelektGrafKey, CDialog)
	//{{AFX_MSG_MAP(CSelektGrafKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektGrafKey message handlers
//----------------------------------------------------------------------------
// ENum->Graphic
//----------------------------------------------------------------------------
BOOL CSelektGrafKey::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;
	              
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetPartNr_x()
{
	return m_PartNr_x;
}

void	CSelektGrafKey::SetPartNr_x( int value)
{
	if (value > 0)
	{
		m_PartNr_x = value;
	}
	else
	{
		m_PartNr_x = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetCharNr_x()
{
	return m_CharNr_x;
}
void	CSelektGrafKey::SetCharNr_x( int value)
{
	if (value > 0)
	{
		m_CharNr_x = value;
	}
	else
	{
		m_CharNr_x = 1;
	}
}


//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetPartNr_y()
{
	return m_PartNr_y;
}

void	CSelektGrafKey::SetPartNr_y( int value)
{
	if (value > 0)
	{
		m_PartNr_y = value;
	}
	else
	{
		m_PartNr_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetCharNr_y()
{
	return m_CharNr_y;
}
void	CSelektGrafKey::SetCharNr_y( int value)
{
	if (value > 0)
	{
		m_CharNr_y = value;
	}
	else
	{
		m_CharNr_y = 1;
	}
}


//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetGraphicKey()
{
	return m_GrafKey;
}
void	CSelektGrafKey::SetGraphicKey( int value)
{
	if (value >= 1000)
	{
		m_GrafKey = value;
	}
	else{
		m_GrafKey = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetGraphicSubkey()
{
	return m_GrafSubKey;
}

void	CSelektGrafKey::SetGraphicSubkey( int value)
{
	if (value >= 0)
	{
		m_GrafSubKey = value;
	}
	else
	{
		m_GrafSubKey = 0;
	}
}


//------------------------------------------------------------------
//------------------------------------------------------------------
BOOL	CSelektGrafKey::GetUseExtFunc()
{
	return m_UseExtFunc;
}
void	CSelektGrafKey::SetUseExtFunc( BOOL value)
{
  	m_UseExtFunc = value;
}


//------------------------------------------------------------------
//------------------------------------------------------------------

void CSelektGrafKey::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumGraphic,(void**)&pIqsSTATGraphic);

	pqsSTATHandle = qsSTATHandle;
}

void CSelektGrafKey::OnOK() 
{
	CDialog::OnOK();
}


void CSelektGrafKey::OnRa() 
{
	// TODO: Add your control notification handler code here
	
}

void CSelektGrafKey::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	
}
