// SelektPrintDialog.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient1.h"
#include "SelektPrintDialog.h"
#include "afxtempl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektPrintDialog dialog


CSelektPrintDialog::CSelektPrintDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSelektPrintDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektPrintDialog)
	//}}AFX_DATA_INIT
}


void CSelektPrintDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektPrintDialog)
	DDX_Control(pDX, IDC_COMBOPRN, m_ComboBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelektPrintDialog, CDialog)
	//{{AFX_MSG_MAP(CSelektPrintDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektPrintDialog message handlers

CSelektPrintDialog::~CSelektPrintDialog()
{
	int i;
	PrinterStruct* pPrinter;
 
	
	for (i = 0; i < PrinterArray.GetSize();i++)
	{	
		pPrinter = PrinterArray.GetAt(i);
		delete pPrinter;
	}
} 


void CSelektPrintDialog::OnOK() 
{	
    PrinterStruct * pPI;
    int index = m_ComboBox.GetCurSel();
    pPI = PrinterArray.GetAt(index);
	PrinterNr = pPI->PrnID;
	CDialog::OnOK();
}

//------------------------------------------------------------------
//------------------------------------------------------------------

BOOL CSelektPrintDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	long	PrinterNr = 0;
	BSTR	PrinterName;
	CString Str;
	int	rc;
	int i = 0;
	
	rc = pIqsSTATPrinter->GetFirstPrinter(pqsSTATHandle,&PrinterNr,&PrinterName);
	while (rc == 0)	
	{
		PrinterStruct* pPrinter = new PrinterStruct;
		pPrinter->PrnID = PrinterNr;
		Str  = PrinterName;
		LPCTSTR p = Str.GetBuffer(Str.GetLength());
		strcpy(pPrinter->PrnName, p);

		// add to combobox
		m_ComboBox.AddString(p);
		// Add to internal list
		PrinterArray.Add(pPrinter);
		rc = pIqsSTATPrinter->GetNextPrinter(pqsSTATHandle,&PrinterNr,&PrinterName);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//------------------------------------------------------------------
//------------------------------------------------------------------

void CSelektPrintDialog::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumPrinter,(void**)&pIqsSTATPrinter);

	pqsSTATHandle = qsSTATHandle;
}

//------------------------------------------------------------------
//------------------------------------------------------------------

int	CSelektPrintDialog::GetPrinterNr()
{
	return PrinterNr;
}
