// SelektReportKey.cpp : implementation file
//

#include "stdafx.h"

#include "VCPPCOMClient1.h"
#include "SelektReportKey.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektReportKey dialog

CSelektReportKey::CSelektReportKey(CWnd* pParent /*= NULL*/)   // standard constructor
: CDialog(CSelektReportKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektReportKey)
	m_PartNr_x = 0;
	m_CharNr_x = 0;
	m_ValueNr_x = 0;
	m_PartNr_y = 0;
	m_CharNr_y = 0;
	m_ValueNr_y = 0;
	m_Height = 0;
	m_Width = 0;
	m_CheckPrn = FALSE;
	//}}AFX_DATA_INIT
	pIqsSTATReport = NULL;
	SelItem = -1;
}
	
void CSelektReportKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektReportKey)
	DDX_Control(pDX, IDC_LIST, m_ListControl);
	DDX_Text(pDX, IDC_PartNr_x, m_PartNr_x);
	DDX_Text(pDX, IDC_CharNr_x, m_CharNr_x);
	DDX_Text(pDX, IDC_ValueNr_x, m_ValueNr_x);
	DDX_Text(pDX, IDC_PartNr_y, m_PartNr_y);
	DDX_Text(pDX, IDC_CharNr_y, m_CharNr_y);
	DDX_Text(pDX, IDC_ValueNr_y, m_ValueNr_y);
	DDX_Text(pDX, IDC_Height, m_Height);
	DDX_Text(pDX, IDC_Width, m_Width);
	DDX_Check(pDX, IDC_CHECKPRN, m_CheckPrn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelektReportKey, CDialog)
	//{{AFX_MSG_MAP(CSelektReportKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektReportKey message handlers

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int		CSelektReportKey::GetPartNr_x()
{
	return m_PartNr_x;
}

void	CSelektReportKey::SetPartNr_x( int value)
{
	if (value > 0)
	{
		m_PartNr_x = value;
	}
	else
	{
		m_PartNr_x = 1;
	}
}
//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektReportKey::GetCharNr_x()
{
	return m_CharNr_x;
}
void	CSelektReportKey::SetCharNr_x( int value)
{
	if (value > 0)
	{
		m_CharNr_x = value;
	}
	else
	{
		m_CharNr_x = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektReportKey::GetValueNr_x()
{
	return m_CharNr_x;
}
void	CSelektReportKey::SetValueNr_x( int value)
{
	if (value > 0)
	{
		m_ValueNr_x = value;
	}
	else
	{
		m_ValueNr_x = 0;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektReportKey::GetPartNr_y()
{
	return m_CharNr_x;
}
void	CSelektReportKey::SetPartNr_y( int value)
{
	if (value > 0)
	{
		m_PartNr_y = value;
	}
	else
	{
		m_PartNr_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int	CSelektReportKey::GetCharNr_y()
{
	return m_CharNr_x;
}
void CSelektReportKey::SetCharNr_y(int value)
{
	if (value > 0)
	{
		m_CharNr_y = value;
	}
	else
	{
		m_CharNr_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------

int	CSelektReportKey::GetValueNr_y()
{
	return m_CharNr_x;
}
void CSelektReportKey::SetValueNr_y(int value)
{
	if (value > 0)
	{
		m_ValueNr_y = value;
	}
	else
	{
		m_ValueNr_y = 0;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int	CSelektReportKey::GetWidth()
{
	return m_Width;
}
void CSelektReportKey::SetWidth(int value)
{
	if (value > 0)
	{
		m_Width = value;
	}
	else
	{
		m_Width = 0;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int	CSelektReportKey::GetHeight()
{
	return m_Height;
}
void	CSelektReportKey::SetHeight(int value)
{
	if (value > 0)
	{
		m_Height = value;
	}
	else
	{
		m_Height = 0;
	}
}
//------------------------------------------------------------------
//------------------------------------------------------------------

void CSelektReportKey::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumReport,(void**)&pIqsSTATReport);

	pqsSTATHandle = qsSTATHandle;
}

//------------------------------------------------------------------
//------------------------------------------------------------------

BOOL CSelektReportKey::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	long	ReportNr = 0;
	BSTR	ReportName;
	BSTR	ReportFileName;
	CString Str;
	int		rc;
	int		i;
	char	buffer[255];

	m_ListControl.InsertColumn(0, "#", LVS_REPORT, 20);
	m_ListControl.InsertColumn(1, "Report File Name", LVS_REPORT, 110);
	m_ListControl.InsertColumn(2, "Report Name", LVS_REPORT, 170);

	i = 0;
	rc = pIqsSTATReport->GetFirstReport(pqsSTATHandle,&ReportNr,&ReportName,&ReportFileName);
	while (rc == 0)	
	{
		Str  = ReportFileName;
		LPTSTR p = Str.GetBuffer(Str.GetLength());
		_itoa(i + 1, buffer, 10 );
		m_ListControl.InsertItem(i, buffer);
		m_ListControl.SetItem(i, 1, LVS_REPORT, p, 0,0,0,0);
		ReportArr.Add(Str);
		Str.ReleaseBuffer();
		Str  = ReportName;
		p = Str.GetBuffer(Str.GetLength());
		m_ListControl.SetItem(i, 2, LVS_REPORT, p, 0,0,0,0);
		Str.ReleaseBuffer();
		i++;
		rc = pIqsSTATReport->GetNextReport(pqsSTATHandle,&ReportNr,&ReportName,&ReportFileName);
	}

	// Enable full row selection on List View*
	m_ListControl.SetExtendedStyle(m_ListControl.GetExtendedStyle()|LVS_EX_FULLROWSELECT);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
//------------------------------------------------------------------
//------------------------------------------------------------------

int CSelektReportKey::GetCheckPrn()
{
	return m_CheckPrn;
}
void CSelektReportKey::SetCheckPrn(BOOL value) 
{
	m_CheckPrn = value;
}

CString CSelektReportKey::GetReportFileName()
{
	if (SelItem > -1)
	{
		return ReportArr.GetAt(SelItem);
	}
	else
	{
		return "-1";
	}
}
void CSelektReportKey::OnOK() 
{
	SelItem = m_ListControl.GetNextItem(-1, LVNI_SELECTED);
	CDialog::OnOK();
}
