#if !defined(AFX_CSelektDialog_H__0DDB70D4_26A8_11D6_8A95_00105AD88C31__INCLUDED_)
#define AFX_CSelektDialog_H__0DDB70D4_26A8_11D6_8A95_00105AD88C31__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"
#include "afxwin.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CSelektDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSelektDialog dialog

struct ModuleStruct
{
	int ModKey;
	char ModName[255];
};

struct LanguageStruct
{
	int LangKey;
	char LangName[255];
};

struct StrategyStruct
{
	int StratKey;
	char StratName[255];
};

struct PrinterStruct
{
	int PrnID;
	char PrnName[255];
};

struct DATABASEStruct
{
	int DBKey;
	BSTR DBName;
};

class CSelektDialog : public CDialog
{
// Construction
public:

	CSelektDialog(CWnd * pParent = NULL);   // standard constructor	
	virtual	~CSelektDialog();
	
	long	pqsSTATHandle;

	void	SetItemType(int Tag);

	void	SetServerObject(IUnknown * pIUnknown, long qsSTATHandle, long Module);
	
	
	CArray<ModuleStruct *, ModuleStruct*> ModuleArray;
	IEnumModule *	pIqsSTATModule;

	CArray<LanguageStruct *, LanguageStruct*> LanguageArray;
	IEnumLanguage *	pIqsSTATLanguage;

	CArray<StrategyStruct *, StrategyStruct*> StrategyArray;
	IEnumEvaluationStrategy *	pIqsSTATStrategy;

	CArray<PrinterStruct *, PrinterStruct*> PrinterArray;
	IEnumPrinter *	pIqsSTATPrinter;

	CArray<DATABASEStruct *, DATABASEStruct*> DBArray;
	IEnumDBSelectionName *	pIqsSTATDB;


//	void	SetModule();
	int		GetModKey();
	
//	void	SetLanguage();
	int		GetLangKey();

//    void	SetModule();
	int		GetStratKey();
	
	int		GetPrinterNr();

//	void	SetLanguage();
	CString	GetDBName();
	
	int		ModKey;
	int		LangKey;
	int		StratKey;
	int		PrinterNr;
	CString	DBName;

	int Type;
	
	long qs_Module;

// Dialog Data
	//{{AFX_DATA(CSelektDialog)
	enum { IDD = IDD_ENUMDIALOG };
	CComboBox	m_COB_ENUM;
	CStatic		m_LA_ENUM;
	CComboBox	m_ComboBox;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSelektDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSelektDialog)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CSelektDialog_H__0DDB70D4_26A8_11D6_8A95_00105AD88C31__INCLUDED_)
