// SelektChar.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient2.h"
#include "SelektChar.h"
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektChar dialog


CSelektChar::CSelektChar(CWnd* pParent /*=NULL*/)
	: CDialog(CSelektChar::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektChar)
	m_Key = 2002;
	m_Subkey = 0;
	m_Part = 1;
	m_Char = 1;
	m_Result = _T("");
	//}}AFX_DATA_INIT
}


void CSelektChar::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektChar)
	DDX_Control(pDX, IDC_COB_CHAR, m_COB_CHAR);
	DDX_Text(pDX, IDC_ED_Key, m_Key);
	DDX_Text(pDX, IDC_ED_SubKey, m_Subkey);
	DDX_Text(pDX, IDC_ED_Part, m_Part);
	DDX_Text(pDX, IDC_ED_Char, m_Char);
	DDX_Text(pDX, IDC_ED_Result, m_Result);	
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelektChar, CDialog)
	//{{AFX_MSG_MAP(CSelektChar)
	ON_BN_CLICKED(IDC_BB_GetResult, OnBBGetResult)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektChar message handlers

//------------------------------------------------------------------
//------------------------------------------------------------------
void CSelektChar::SetServerObject(IUnknown* pIUnknown, 
								  long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumFieldKeyName,(void**)&pIqsSTATChar);
    pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);
	pqsSTATHandle = qsSTATHandle;
}

BOOL CSelektChar::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	long		KFieldKey=0;
	long		KFieldSubKey=0;
	CComBSTR	KFieldName;
	CString		Str;
	int			rc;
	char		s_str[255];

	rc = pIqsSTATChar->GetFirstCharacteristicField(pqsSTATHandle,
								     			   &KFieldKey,
									               KFieldSubKey,
										           &KFieldName);
	while (rc == 0)	
	{
		Str  = KFieldName;
	    sprintf(s_str, "%s %s%d%s", Str, "(", KFieldKey, ")");
		m_COB_CHAR.AddString(s_str);
		rc = pIqsSTATChar->GetNextCharacteristicField(pqsSTATHandle,
								     			      &KFieldKey,
													  KFieldSubKey,
													  &KFieldName);
	}
	m_COB_CHAR.SetCurSel(0);
	
	return TRUE;	
}

void CSelektChar::OnOK() 
{
	CDialog::OnOK();
}

void CSelektChar::OnBBGetResult() 
{

	BSTR	ValueText;
	HRESULT	hr;

	UpdateData(TRUE);
	if (pqsSTAT)
	{
		hr = pqsSTAT->GetCharInfo(pqsSTATHandle,
								  m_Key,
								  m_Part,
								  m_Char,
								  &ValueText);

		if (hr == S_OK)
		{
			m_Result = CString(ValueText);
		}
		else
		{
			m_Result = "Error";
		}
		UpdateData(FALSE);
	}
}
