#if !defined(AFX_SELEKTREPORTKEY_H__FAA58785_1F0A_11D6_8A8B_00105AD88C31__INCLUDED_)
#define AFX_SELEKTREPORTKEY_H__FAA58785_1F0A_11D6_8A8B_00105AD88C31__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "UpdateView.h"
#include "resource.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SelektReportKey.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSelektReportKey dialog

class CSelektReportKey : public CDialog
{
// Construction
public:

	CSelektReportKey(CWnd* pParent = NULL);   // standard constructor

	void	SetServerObject(CUpdateView* view,
							IUnknown* pIUnknown, 
							long qsSTATHandle);

	ITQsstatRemoteControl*	pqsSTAT;

	IEnumReport*	pIqsSTATReport;
	
	CUpdateView* pView;
	
	long	pqsSTATHandle;

	int		GetPageNr();
	
	void	SetPages();

	int		GetPartNr_x();
	void	SetPartNr_x(int value);

	int		GetCharNr_x();
	void	SetCharNr_x(int value);

	int		GetValueNr_x();
	void	SetValueNr_x(int value);

	int		GetPartNr_y();
	void	SetPartNr_y(int value);

	int		GetCharNr_y();
	void	SetCharNr_y(int value);

	int		GetValueNr_y();
	void	SetValueNr_y(int value);

	int		SelItem;

	CString GetReportFileName();

	CStringArray ReportArr;
	BSTR ReportFileName;
	long ReportNr;

// Dialog Data
//{{AFX_DATA(CSelektReportKey)
	enum { IDD = IDD_SELECTREPORTKEY_DIALOG };
	CButton	m_GetPages;
	CButton	m_Apply;
	CButton	m_PageBwd;
	CButton	m_PageFwd;
	CComboBox	m_ENUMReport;
	int		m_PageNr;
	int		m_Pages;
	int		m_CharNr_x;
	int		m_CharNr_y;
	int		m_PartNr_x;
	int		m_PartNr_y;
	int		m_ValueNr_x;
	int		m_ValueNr_y;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSelektReportKey)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSelektReportKey)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnBBGetPages();
	afx_msg void OnBBPageBWD();
	afx_msg void OnBBPageFWD();
	afx_msg void OnBBApply();
	afx_msg void OnEditchangeReport();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
			
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SELEKTREPORTKEY_H__FAA58785_1F0A_11D6_8A8B_00105AD88C31__INCLUDED_)
