#if !defined(AFX_SELEKTSTATKEY_H__FF2E9588_EFE0_11D5_A7B9_00105A274BB6__INCLUDED_)
#define AFX_SELEKTSTATKEY_H__FF2E9588_EFE0_11D5_A7B9_00105A274BB6__INCLUDED_

#include "qs_stat.h"
#include "afxcmn.h"
#include "afxtempl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SelektStatKey.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSelektStatKey dialog

class CSelektStatKey : public CDialog
{
// Construction
public:
	CSelektStatKey(CWnd* pParent = NULL);

	void	SetServerObject(IUnknown* pIUnknown, 
							long qsSTATHandle,
							long module);

	ITQsstatRemoteControl*	pqsSTAT;

	IEnumStatResults*	pIqsSTATStatResult;

	long	pqsSTATHandle;
	
	void	GetResult();
	void	GetStatResult();

	int		GetStatResultKey();
	void	SetStatResultKey( int value);

	int		GetStatResultSubkey();
	void	SetStatResultSubkey( int value);

	int		GetTransformation();

	int		GetPartNr();
	void	SetPartNr( int value);

	int		GetCharNr();
	void	SetCharNr( int value);

	long	qs_Module;

	long	Transform;

// Dialog Data
	//{{AFX_DATA(CSelektStatKey)
	enum { IDD = IDD_SELECTSTATKEY_DIALOG };
	CComboBox	m_ENUMStatResult;
	int		m_StatResultKey;
	int		m_StatResultSubkey;
	int		m_CharNr;
	int		m_PartNr;
	CString	m_StatResult;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSelektStatKey)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSelektStatKey)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnBBGetResult();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	afx_msg void OnRadio3();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SELEKTSTATKEY_H__FF2E9588_EFE0_11D5_A7B9_00105A274BB6__INCLUDED_)
